;*************************************************************************
;
; Package contenant le tout gris, le jav
;
; Créé par ZWFrance - Fonctionnel pour ZWCad
; 
;*************************************************************************
;
;JAV
;
;*************************************************************************
(defun patrick:jav( bda / *errjav* app arg att bl bd_appli cde cle dcl dic doc ent img
			  jav lancer lgt lst lst_lay lst_ech lst_maxi maxi old s sel
			  tdi tot tota txt var
			  tmp nbBoucle nbBoucleMax lst_lay_freeze ; Variables Johan
			  appli bd bits C30 del_dic eff inputbox nombl msg msgbox opt
			  select liste_echelles RightCleanText)

;=========================================================================
; Gestion des erreurs
;=========================================================================

  (defun *errjav* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (mapcar '(lambda(x) (vla-put-lock (car x) (cdr x))) lst_lay)
    (vla-endundomark doc)
    (setq *error* s)
    (princ)
  )

;=========================================================================
; Nom du bloc
;=========================================================================

  (defun nombl(bl)
    (if (vlax-property-available-p bl 'effectivename)
      (vla-get-effectivename bl)
      (vla-get-name bl)
    )
  )

;=========================================================================
; Afficher un message via une boite de dialogue
;=========================================================================

  (defun msgbox (titre bouttons message / reponse wshshell)
    (acad-push-dbmod)
    (setq wshshell (vlax-create-object "WScript.Shell"))
    (setq reponse (vlax-invoke wshshell 'popup message 0 titre (itoa bouttons)))
    (vlax-release-object wshshell)
    (acad-pop-dbmod)
    reponse
  )

;=========================================================================
; Boite de dialogue Options
;=========================================================================

  (defun opt(titre / dcl fil tmp txt)
    (setq tmp (vl-filename-mktemp "opt" nil ".dcl")
	  fil (open tmp "w")

    )
    (foreach txt (list	"opt : dialog {"
			"  key = titre;"
			"  is_cancel = true;"
			"  fixed_width = true;"
			"  alignment = centered;"
			"  : row {"
			"    : boxed_column {"
			"      label = \"Nettoyer, vérifier\";"
			"      width = 35;"
			(strcat "      : toggle {key = \"" (itoa (expt 2  0)) "\"; label = \"Contrôle des erreurs.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 16)) "\"; label = \"Purger le dessin.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  1)) "\"; label = \"Purger les applications.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 10)) "\"; label = \"Liste d'échelles.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 12)) "\"; label = \"Filtres de calques.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 11)) "\"; label = \"Liens dxe.\";}")

			(strcat "      : toggle {key = \"" (itoa (expt 2 19)) "\"; label = \"Polices et formes SHX.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 17)) "\"; label = \"Images (raster) orphelines.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 21)) "\"; label = \"Xrefs orphelins.\";}")
			"      spacer;"
			"    }"
			"    : boxed_column {"
			"      label = \"Inutiles dans le dessin\";"
			"      width = 35;"
			(strcat "      : toggle {key = \"" (itoa (expt 2  2)) "\"; label = \"Lignes de longueur 0.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  3)) "\"; label = \"Textes vide.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  4)) "\"; label = \"Blocs vide.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  5)) "\"; label = \"Groupes vide.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 22)) "\"; label = \"Présentations vide.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 14)) "\"; label = \"Dictionnaires vide.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 18)) "\"; label = \"Caractères non imprimable.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 20)) "\"; label = \"Wipeouts (polylignes de masquages)\";}")
			"      spacer;spacer;spacer;spacer;"
			"    }"
			"  }"
			"  spacer;"
			" : text {value =\"En cochant Polices et formes SHX, des SHX de\";}"
			" : text {value =\"remplacement seront ajoutés dans le dossier de support.\";}"
			"  spacer;"
			"  : row {"
			"    : boxed_column {"
			"      label = \"Effacer objets ARX/Proxys\";"
			"      width = 35;"
			(strcat "      : toggle {key = \"" (itoa (expt 2  7)) "\"; label = \"Proxys.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  8)) "\"; label = \"Zombies Blocs.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2  9)) "\"; label = \"Zombies Dictionnaires.\";}")
			"      spacer;"
			"    }"
			"    : boxed_column {"
			"      label = \"Attention, peut-être sensible\";"
			"      width = 35;"
			(strcat "      : toggle {key = \"" (itoa (expt 2  6)) "\"; label = \"Effacer Xdatas.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 13)) "\"; label = \"Nettoyer  Dictionnaires.\";}")
			(strcat "      : toggle {key = \"" (itoa (expt 2 15)) "\"; label = \"Supprimer Dictionnaires.\";}")
			"      spacer;"
			"    }"
			"  }"
			"  spacer;"
			"  : row {"
			"    : boxed_column {"
			"      width = 33;"
			"      label = \"Lancer une/des application(s)\";"

			"      : row {"
			"        : toggle {label = \"Activer\"; key = \"acti\";}"
			"        : button {label = \"Sélection\"; key = \"choix\";}"
			
			"      }"

			"      spacer;"
					
			"    }"
			"    : row {"
			"      width = 36;"
			"      spacer;"
			"      : column {"
			"        : button {key = \"tout\";  label = \"Tout\";}"
			"        : button {key = \"aucun\"; label = \"Aucun\";}"
			"        spacer;"
			"      }"
			"      : column {"
			"        ok_button;"
			"        cancel_button;"
			"        spacer;"
			"      }"
			"    }"
			"  }"
			"  spacer;"
			"}"
		 )
      (write-line txt fil)
    )
    (close fil)
    (setq dcl (load_dialog tmp))
    (new_dialog "opt" dcl "")
    (set_tile "titre" titre)
    (mapcar '(lambda(x) (or (zerop (logand var x)) (set_tile (itoa x) "1")))
	    lst_maxi
    )
    (mode_tile "appli" 1)
    (set_tile "acti" lancer)
    (cons dcl tmp)
  )

;=========================================================================
; Boite de dialogue Rapport
;=========================================================================

  (defun bd(titre / dcl fil tmp txt)
    (setq tmp (vl-filename-mktemp "rap" nil ".dcl")
	  fil (open tmp "w")
    )
    (foreach txt '(	"msg : dialog {"
			"  key = titre;"
			"  is_cancel = true;"
			"  fixed_width = true;"
			"  alignment = centered;"
			"  : list_box {key = \"lst\"; multiple_select = true; width = 80; height = 50;}"
			"  ok_button;"
			"}"
		 )
      (write-line txt fil)
    )
    (close fil)
    (setq dcl (load_dialog tmp))
    (new_dialog "msg" dcl "")
    (set_tile "titre" titre)
    (mode_tile "accept" 1)
    (cons dcl tmp)
  )

;=========================================================================
; Boite de dialogue Applications
;=========================================================================

  (defun bd_appli(titre / dcl fil tmp txt)
    (setq tmp (vl-filename-mktemp "app" nil ".dcl")
	  fil (open tmp "w")
    )
    (foreach txt '(	"app : dialog {"
			"  key = titre;"
			"  is_cancel = true;"
			"  fixed_width = true;"
			"  alignment = centered;"
			"  : row {"
			"    : list_box {label =\"Application\"; key = \"lst\"; multiple_select = true; width = 50;}"
			"    : column {"
			"      spacer_1;"
			"      : button {label = \"Ajouter\";   key = \"ajout\";}"
			"      : button {label = \"Modifier\";  key = \"modif\";}"
			"      : button {label = \"Supprimer\"; key = \"suppr\";}"
			"      spacer_1; spacer_1; spacer_1;"
			"      : button {label = \"Haut\"; key = \"haut\";}"
			"      : button {label = \"Bas\";  key = \"bas\";}"
			"      spacer_1; spacer_1; spacer_1;"
			"    }"
			"    spacer;"
			"  }"
			"  : text {label = \"Fichier :\"; key = \"fich\";}"
			"  : text {label = \"Arguments :\"; key = \"args\";}"
			"  spacer;"
			"  ok_cancel;"
			"}"
		 )
      (write-line txt fil)
    )
    (close fil)
    (setq dcl (load_dialog tmp))
    (new_dialog "app" dcl "")
    (set_tile "titre" titre)
    (cons dcl tmp)
  )

;=========================================================================
; Boite de dialogue Commande + arguments
;=========================================================================

  (defun inputbox (titre js1 js2 opt fir / ch dcl fil res tmp txt)
    (setq tmp (vl-filename-mktemp "cmd" nil ".dcl")
	  fil (open tmp "w")
    )
    (foreach txt '(	"lsp : dialog {"
			"  key = \"titre\";"
			"  alignment = centered;"
			"  is_cancel = true;"
			"  allow_accept = true;"
			"  : text {key = \"fir\";}"
			"  spacer;"
			"  : row {"
			"    : column {"
			"      width = 8;"
			"      : text {label = \"Commande\";}"
			"      spacer;"
			"      : text {label = \"Arguments\"; key = \"txt\";}"
			"    }"
			"    : column {"
			"      width = 40;"
			"      : edit_box {key= \"cmd\";}"
			"      spacer;"
			"      : edit_box {key= \"arg\";}"
			"    }"
			"  }"
			"  spacer;"
			"  ok_cancel;"
			"}"
		 )
      (write-line txt fil)
    )
    (close fil)
    (setq dcl (load_dialog tmp))
    (new_dialog "lsp" dcl "")
    (set_tile "titre" titre)
    (set_tile "cmd" js1)
    (set_tile "arg" js2)
    (set_tile "fir" fir)
    (mode_tile "arg" opt)
    (mode_tile "txt" opt)
    (mode_tile "cmd" 2)
    (action_tile "cmd" "(setq js1 $value)")
    (action_tile "arg" "(setq js2 $value)")
    (action_tile "cancel" "(done_dialog 0)")
    (action_tile "accept" "(done_dialog 1)")
    (setq res (start_dialog))
    (unload_dialog dcl)
    (vl-file-delete tmp)
    (if (eq res 1)
      (list js1 js2)
      (list "" "")
    )
  )

;=========================================================================
; Selectionner Tout/Aucun
;=========================================================================
  (defun select(bit)
    (mapcar '(lambda(x) (set_tile (itoa x) bit))
	    lst_maxi
    )
    (if (eq bit "0")
      (setq var 0)
      (setq var maxi)
    )
  )

;=========================================================================
; Afficher un message
;=========================================================================

  (defun msg(msg)
  	(setq tmp tot)
    (setq tot 0)
    (if bda
      (progn
	(start_list "lst" 2)
	  (if (eq (vl-string-elt msg (1- (strlen msg))) 10)
	  (progn
	    (add_list (substr msg 1 (1- (strlen msg))))
	    (add_list "")
	  )
	  (add_list msg)
	)
	(end_list)
      )
      (progn
	(terpri)
	(princ msg)
      )
    )
  )

;=========================================================================
; Ajouter/enlever un bit
;=========================================================================

  (defun bits(bit)
    (setq var (boole 6 var bit))
  )

;=========================================================================
; Effacer un dictionnaire
;=========================================================================

  (defun del_dic(rec / dic tot)
    (if (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-get-dictionaries doc) rec))))
      (setq tot 0)
      (progn
	(setq tot (vla-get-count dic))
	(vl-catch-all-apply 'vla-delete (list dic))
      )
    )
    tot
  )

;=========================================================================
; Effacer un élement
;=========================================================================

  (defun eff(ent)
    (or (vl-catch-all-error-p (vl-catch-all-apply 'vla-delete (list ent)))
      (setq tot (1+ tot))
    )
  )

;=========================================================================
; Faire un chiffre de 3 caractères (ex : 003)
;=========================================================================

    (defun c30(val)
      (setq val (itoa val))
      (while (< (strlen val) 3) (setq val (strcat "0" val)))
      val
    )

;=========================================================================
; Gerer les applications
;=========================================================================

  (defun appli(/ arg der dcl ext lsp lst n pos_lst rep
		 aff_fichier ajouter bas elem haut modifier selection supprimer)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Afficher correctement le fichier, découpe le texte si nécessaire
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun aff_fichier(str / txt)
      (if (> (strlen str) 70)
	(setq txt (strcat (substr str 1 (- 62 (strlen (vl-filename-base str))))
			  "...\\"
			  (vl-filename-base str)
			  (vl-filename-extension str)
		  )
	)
	(setq txt str)
      )
      (set_tile "fich" txt)
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Affiche le nom de fichier + arguments suivant la sélection
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun selection(cle / der emp pos pre tmp val)
      (and lst
	(progn
	  (and (> (length lst) 1)
	    (mapcar '(lambda(x) (mode_tile x 0)) '("haut" "bas"))
	  )
	  (if (vl-string-search " " cle)
	    (progn
	      (set_tile "fich" "Fichiers : Varié")
	      (set_tile "args" "Arguments : Varié")
	      (setq emp cle
		    pre (read emp)
	      )
	      (while (setq pos (read emp))
		(setq der pos
		      emp (substr emp (+ 2 (strlen (itoa pos))))
		)
		(and tmp
		     (not (eq pos (1+ tmp)))
		  (setq val T)
		)
		(setq tmp pos)
	      )
	      (or val
		(progn
		  (and (eq pre 0) (mode_tile "haut" 1))
		  (and (eq der (1- (length lst))) (mode_tile "bas" 1))
		)
	      )
	    )
	    (progn
	      (aff_fichier (car (nth (read cle) (reverse lst))))
	      (set_tile "args" (strcat "Argument : " (caddr (nth (read cle) (reverse lst)))))
	      (if (eq (read cle) 0)
		(mode_tile "haut" 1)
	      )
	      (if (eq (read cle) (1- (length lst)))
		(mode_tile "bas" 1)
	      )
	    )
	  )
	  (setq pos_lst cle)
	)
      )
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Affiche un élement de la liste
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun elem(rep)
      (add_list (if (= (cadr rep) "")
		  (strcat (vl-filename-base (car rep))(vl-filename-extension (car rep)))
		  (cadr rep)
		)
      )
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Ajouter une application
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun ajouter(/ ext fic rep)
      (or (setq der (vl-registry-read cle "Dernier"))
	(setq der (findfile "jav.lsp"))
      )
      (and (setq fic (getfiled "Sélectionnez l'application" (vl-filename-directory der) "lsp;dvb;scr;arx;dll" 16))
	(progn
	  (setq der fic
		ext (strcase (vl-filename-extension fic))
	  )
	  (cond
	    ((member ext '(".LSP" ".DVB"))
	      (setq arg 1)
	    )
	    ((eq ext ".SCR")
	      (setq arg 2)
	    )
	    (T
	      (setq arg 0)
	    )
	  )
	  (if (= arg 2)
	    (setq rep (list "" ""))
	    (setq rep (inputbox (strcat "Ajouter une application " jav) "" "" arg fic))
	  )
	  (and	(setq rep (list fic (car rep) (if (eq arg 1) "" (cadr rep))))
		(not (member rep lst))
		(setq lst (cons rep lst))
	    (progn
	      (start_list "lst" 2)
	      (elem rep)
	      (end_list)
	      (set_tile "lst" "")
	      (set_tile "lst" (setq pos_lst (itoa (1- (length lst)))))
	      (mapcar '(lambda(x) (mode_tile x 0)) '("modif" "suppr"))
	      (or (eq (length lst) 1) (mode_tile "haut" 0))
	      (selection pos_lst)
	    )
	  )
	)
      )
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Modifier une application
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun modifier(/ arg emp fic pos rep tab)
      (setq emp pos_lst
	    tab (reverse lst)
      )
      (while (setq pos (read emp))
	(setq rep (nth pos tab)
	      emp (substr emp (+ 2 (strlen (itoa pos))))
	)

	(and (setq fic (getfiled "Sélectionnez l'application" (vl-filename-directory (car rep)) "lsp;dvd;scr;arx;dll" 16))
	  (setq rep (subst fic (car rep) rep)
		der fic
	  )
	)
	(setq fic (car rep))
	(if (eq (strcase (vl-filename-extension fic)) ".SCR")
	  (setq rep (cons fic '("" "")))
	  (progn
	    (if (member (strcase (vl-filename-extension fic)) '(".LSP" ".DVB"))
	      (setq arg 1)
	      (setq arg 0)
	    )
	    (setq rep (inputbox (strcat "Modifier une application " jav) (cadr rep) (if (eq arg 1)
										      ""
										      (caddr rep)
										    )
										    arg
										    fic
		      )
	    )
	    (if (eq (car rep) "")
	      (setq rep (cons fic (cdr (nth pos tab))))
	      (setq rep (cons fic rep))
	    )
	  )
	)
	(setq tab (subst rep (nth pos tab) tab))
	(start_list "lst" 1 pos)
	(elem rep)
	(end_list)
      )
      (setq lst (reverse tab))
      (selection pos_lst)
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Supprimer une application
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun supprimer(/ emp old pos tab)
      (setq emp pos_lst
	    tab (reverse lst)
	    old tab
      )
      (while (setq pos (read emp))
	(setq emp (substr emp (+ 2 (strlen (itoa pos))))
	      tab (vl-remove (nth pos old) tab)
	)
      )
      (setq lst (reverse tab))
      (if lst
	(progn
	  (start_list "lst")
	  (mapcar 'elem (reverse lst))
	  (end_list)
	  (if (vl-string-search " " pos_lst)
	    (setq pos_lst "0")
	    (or (zerop (read pos_lst))
	      (setq pos_lst (itoa (1- (read pos_lst))))
	    )
	  )
	  (selection pos_lst)
	  (set_tile "lst" pos_lst)
	)
	(progn
	  (start_list "lst")
	  (end_list)
	  (mapcar '(lambda(x) (mode_tile x 1)) '("modif" "suppr" "haut" "bas"))
	  (mapcar '(lambda(a b) (set_tile a b)) '("fich" "args") '("Fichier :" "Arguments :"))
	)
      )
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Un coup vers le haut/bas
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun haut(/ emp memo n pos tab tbl str lect)
      (defun lect()
	(setq pos (read emp)
	      emp (substr emp (+ 2 (strlen (itoa pos))))
	)
      )
      (setq tab (reverse lst)
	    emp pos_lst
	    n 0
      )
      (lect)
      (while (nth n tab)
	(if (= (1+ n) pos)
	  (progn
	    (setq tbl (cons (nth (1+ n) tab) tbl))
	    (or memo (setq memo (nth n tab)))
	    (or (= emp "") (lect))
	  )
	  (if memo
	    (setq tbl (cons memo tbl)
		  memo nil
	    )
	    (setq tbl (cons (nth n tab) tbl))
	  )
	)
	(if (eq n pos)
	  (or (= emp "") (lect))
	)
	(setq n (1+ n))
      )
      (start_list "lst")
      (mapcar 'elem (reverse tbl))
      (end_list)
      (setq lst tbl
	    emp pos_lst
	    n 0
      )
      (while (setq pos (read emp))
	(setq emp (substr emp (+ 2 (strlen (itoa pos)))))
	(or (eq n pos) (setq pos (1- pos)))
	(setq n (1+ n))
	(if str
	  (setq str (strcat str " " (itoa pos)))
	  (setq str (itoa pos))
	)
      )
      (selection str)
      (set_tile "lst" "")
      (set_tile "lst" pos_lst)
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Un coup vers le bas
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (defun bas (/ emp memo n pos tab tbl str lect)
      (defun lect()
	(setq pos (read emp)
	      emp (substr emp (+ 2 (strlen (itoa pos))))
	)
      )
      (setq tab (reverse lst)
	    emp pos_lst
	    n 0
      )
      (lect)
      (while (nth n tab)
	(if (= n pos)
	  (progn
	    (setq memo (cons (nth n tab) memo))
	    (or (= emp "") (lect))
	  )
	  (progn
	    (setq tbl (cons (nth n tab) tbl))
	    (if memo
	      (setq tbl (append memo tbl)
		    memo nil
	      )
	    )
	  )
	)
	(setq n (1+ n))
      )
      (if memo
	(setq tbl (append memo tbl)
	      memo nil
	)
      )
      (start_list "lst")
      (mapcar 'elem (reverse tbl))
      (end_list)
      (setq lst tbl
	    emp pos_lst
	    n 0
      )
      (while (setq pos (read emp))
	(setq emp (substr emp (+ 2 (strlen (itoa pos)))))
	(setq memo (cons pos memo))
      )
      (while (nth n memo)
	(if (eq (+ (nth n memo) n) (1- (length lst)))
	  (setq pos (nth n memo))
	  (setq pos (1+ (nth n memo)))
	)
	(if str
	  (setq str (strcat (itoa pos) " " str))
	  (setq str (itoa pos))
	)
	(setq n (1+ n))
      )
      (selection str)
      (set_tile "lst" "")
      (set_tile "lst" pos_lst)
    )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Routine principale des applications
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    (setq n 0)
    (and (car (setq dcl (bd_appli (strcat "Gestion des applications " jav))))
      (progn
	(while (setq lsp (vl-registry-read cle (strcat "Appli_" (c30 n))))
	  (setq lst (cons (list lsp
				(vl-registry-read cle (strcat "Local_" (c30 n)))
				(vl-registry-read cle (strcat "Args__" (c30 n)))
			  )
			  lst
		    )
		n (1+ n)
	  )
	)
	(if lst
	  (progn
	    (start_list "lst")
	    (mapcar 'elem (reverse lst))
	    (end_list)
	    (selection (vl-registry-read cle "Selection"))
	    (set_tile "lst" pos_lst)
	  )
	  (mapcar '(lambda(x) (mode_tile x 1)) '("modif" "suppr" "haut" "bas"))
	)
	(action_tile "ajout"  "(ajouter)")
	(action_tile "modif"  "(modifier)")
	(action_tile "suppr"  "(supprimer)")
	(action_tile "haut"   "(haut)")
	(action_tile "bas"    "(bas)")
	(action_tile "lst"    "(selection $value)")
        (action_tile "cancel" "(done_dialog 0)")
        (action_tile "accept" "(done_dialog 1)")
        (and (eq (start_dialog) 1)
	  (progn
	    (setq lst (reverse lst)
		  n 0
	    )
	    (while (and lst (setq lsp (nth n lst)))
	      (vl-registry-write cle (strcat "Appli_" (c30 n)) (car  lsp))
	      (vl-registry-write cle (strcat "Local_" (c30 n)) (cadr   lsp))
	      (vl-registry-write cle (strcat "Args__" (c30 n)) (caddr lsp))
	      (setq n (1+ n))
	    )
	    (and der (vl-registry-write cle "Dernier" der))
	    (and pos_lst (vl-registry-write cle "Selection" pos_lst))
	    (while (setq lsp (vl-registry-read cle (strcat "Appli_" (c30 n))))
	      (vl-registry-delete cle (strcat "Appli_" (c30 n)))
	      (vl-registry-delete cle (strcat "Local_" (c30 n)))
	      (vl-registry-delete cle (strcat "Args__" (c30 n)))
	      (setq n (1+ n))
	    )
	  )
	)
        (unload_dialog (car dcl))
        (vl-file-delete (cdr dcl))
      )
    )
  )

;=========================================================================
; Liste des echelles annotatives
;=========================================================================

  (defun liste_echelles(/ dic ele ent lst obj sel typ)
    (vlax-for blo (vla-get-blocks doc)
      (and (eq (vla-get-isxref blo) :vlax-false)
	(vlax-for ent blo
	  (and (eq (vla-get-hasextensiondictionary ent) :vlax-true)
	    (vlax-for dic (vla-getextensiondictionary ent)
	      (and (vlax-property-available-p dic 'name)
		   (eq (vla-get-name dic) "AcDbContextDataManager")
		(vlax-for ele dic
		  (and (eq (vla-get-name ele) "ACDB_ANNOTATIONSCALES")
		    (vlax-for obj ele
		      (setq typ (cdr (assoc 300 (entget (cdr (assoc 340 (entget (vlax-vla-object->ename obj))))))))
		      (or (member typ lst) (setq lst (cons typ lst)))
		    )
		  )
		)
	      )
	    )
	  )
	)
      )
    )
    lst
  )

;=========================================================================
; Effacer les caractères non imprimable
; Merci à BIGC-ROMU pour le lisp et à celui qui l'a écrit (gile)
;=========================================================================

  (defun RightCleanText	(txt / lst)
    (setq lst (reverse (vl-string->list txt)))
    (while (and	lst
		(or (< (car lst) 33)
		    (and (= (car lst) 80) (= (cadr lst) 92))
		)
	   )
      (if (< (car lst) 33)
	(setq lst (cdr lst))
	(setq lst (cddr lst))
      )
    )
    (vl-list->string (reverse lst))
  )

;-------------------------------------------------------------------------
; Initialisation
;-------------------------------------------------------------------------

  (vl-load-com)
  (setq s *error*
	*error* *errjav*
	doc (vla-get-activedocument (vlax-get-acad-object))
	tota 23
	maxi (1- (expt 2 tota))
	jav "JAV v3.39 (ZWCAD)"
	tdi (vla-get-count (vla-get-dictionaries doc))
	tot 1
	cle "HKEY_CURRENT_USER\\Software\\Autodesk\\Autocad\\Patrick_35\\Jav"
  )
  (while (< tot  maxi)
    (setq lst_maxi (cons tot lst_maxi)
	  tot (* tot 2)
    )
  )
  (if (setq var (getenv "Patrick_35_Jav"))
    (setq var (atoi var))
    (setq var maxi)
  )
  (or (setq lancer (getenv "Patrick_35_Jav_App")) (setq lancer "0"))
  (vla-startundomark doc)
  (and bda (car (setq dcl (opt jav)))
    (progn
      (if (< (atof (substr (getvar "acadver") 1 4)) 17.1)
	(progn
	  (or (zerop (logand var (expt 2 10))) (bits (expt 2 10)))
	  (set_tile (itoa (expt 2 10)) "0")
	  (mode_tile (itoa (expt 2 10)) 1)
	  (setq lst_maxi (vl-remove (expt 2 10) lst_maxi))
	)
      )
      (setq tot 0)
      (repeat tota
	(action_tile (itoa (expt 2 tot)) (strcat "(bits " (itoa (expt 2 tot)) " )"))
	(setq tot (1+ tot))
      )
      (action_tile "choix"  "(appli)")
      (action_tile "acti"   "(setq lancer $value)")
      (action_tile "aucun"  "(select \"0\")")
      (action_tile "tout"   "(select \"1\")")
      (action_tile "cancel" "(done_dialog 0)")
      (action_tile "accept" "(done_dialog 1)")
      (setq ent (start_dialog))
      (unload_dialog (car dcl))
      (vl-file-delete (cdr dcl))
    )
  )

  (and (or (not bda) (eq ent 1))
    (progn
      (setenv "Patrick_35_Jav" (itoa var))
      (setenv "Patrick_35_Jav_App" lancer)

  (setq nbBoucleMax 10) ; On se limite à 10 itérations pour éviter les boucles infinies

;-------------------------------------------------------------------------
; Lancer les applications
;-------------------------------------------------------------------------

      (and (eq lancer "1")
	   (vl-registry-read cle "Appli_000")
	   (setq ent (vl-registry-read cle "Selection" ))
	(progn
	  (while (setq dic (read ent))
	    (setq ent (substr ent (+ 2 (strlen (itoa dic))))
		  app (vl-registry-read cle (strcat "Appli_" (c30 dic)))
		  cde (vl-registry-read cle (strcat "Local_" (c30 dic)))
		  arg (vl-registry-read cle (strcat "Args__" (c30 dic)))
		  old cde
	    )
	    (if (findfile app)
	      (cond
		((eq (strcase (vl-filename-extension app)) ".SCR")
		  (vl-cmdf "_.script" app)
		)
		((eq (strcase (vl-filename-extension app)) ".LSP")
		  (load app)
		  (or (eq cde "")
		    (progn
		      (or (eq (vl-string-position 40 cde) 0)
			(setq cde (strcat "(c:" cde ")"))
		      )
		      (and (vl-catch-all-error-p (vl-catch-all-apply 'eval (list (read cde))))
			(msgbox jav 32 (strcat "\nFonction inconnue \"" old "\""))
		      )
		    )
		  )
		)
		((eq (strcase (vl-filename-extension app)) ".DVB")
		  (vla-loaddvb (vlax-get-acad-object) app)
		  (or (eq cde "")
		    (and (vl-catch-all-error-p (vl-catch-all-apply 'vla-runmacro (list (vlax-get-acad-object) cde)))
		      (msgbox jav 32 (strcat "\nFonction inconnue \"" cde "\""))
		    )
		  )
		)
		(T
		  (if (eq (strcase (vl-filename-extension app)) ".ARX")
		    (vla-loadarx (vlax-get-acad-object) app)
		    (vl-cmdf "_.netload" app)
		  )
		  (or (eq cde "")
		    (progn
		      (and (vl-catch-all-error-p (vl-catch-all-apply 'eval (list (read (if (eq arg "")
											 cde
											 (strcat cde " " arg)
										       )
										 )
									   )
						 )
			   )
			(progn
			  (or (eq (vl-string-position 40 cde) 0)
			    (progn
			      (setq cde (strcat "(" cde))
			      (if (eq arg "")
				(setq cde (strcat cde ")"))
				(setq cde (strcat cde " " arg ")"))
			      )
			    )
			  )
			  (and (vl-catch-all-error-p (vl-catch-all-apply 'eval (list (read cde))))
			    (msgbox jav 32 (strcat "\nFonction inconnue \"" old " " arg "\""))
			  )
			)
		      )
		    )
		  )
		)
	      )
	      (msgbox jav 16 (strcat "Fichier " app " introuvable."))
	    )
	  )
	)
      )

;-------------------------------------------------------------------------
; Déverrouiller les calques
;-------------------------------------------------------------------------

      (and (or (not bda) (car (setq dcl (bd (strcat "Rapport " jav)))))
	(progn
	  (vlax-for ent (vla-get-layers doc)
	    (setq lst_lay (cons (cons ent (vla-get-lock ent)) lst_lay))
	    ;(princ lst_lay)
	    (vla-put-lock ent :vlax-false)
	  )


;-------------------------------------------------------------------------
; Dégeler les calques
;-------------------------------------------------------------------------
	(vlax-for lay (vla-get-layers doc)
	  	(setq lst_lay_freeze (cons (cons lay (vla-get-freeze lay)) lst_lay_freeze))
  			(if (eq (vla-get-freeze lay) :vlax-true)
    			(vla-put-freeze lay :vlax-false)
    		)
    )


;-------------------------------------------------------------------------
; Purger les applications
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 1)))
	    (progn
	      (msg "Purger les applications.")
	      (vlax-for dic (vla-get-registeredapplications doc)
		(eff dic)
	      )
	      (msg (strcat "   " (itoa tot) " application(s) effacée(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les lignes/polylignes/splines/arcs/etc... de longueur 0
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 2)))
	    (progn
	    	(setq tmp 1) ; Initialisation (pour rentrer au moins une fois dans la boucle)
	    	(setq nbBoucle 0)
			(while (and (/= tmp 0) (< nbBoucle nbBoucleMax))	    	
			(setq nbBoucle (1+ nbBoucle))
	      (msg "Recherche lignes/polylignes/splines/arcs/etc... de longueur 0.")
	      (vlax-for bl (vla-get-blocks doc)
		(or (wcmatch (nombl bl) "*|*")
		  (vlax-for ent bl
		    (setq lgt 1.0)
		    (cond
		      ((member (vla-get-objectname ent) '("AcDbLine" "AcDb3dPolyline" "AcDbPolyline"))
			(setq lgt (vla-get-length ent))
		      )
		      ((eq (vla-get-objectname ent) "AcDbArc")
			(setq lgt (vla-get-arclength ent))
		      )
		      ((eq (vla-get-objectname ent) "AcDbCircle")
			(setq lgt (vla-get-circumference ent))
		      )
		      ((member (vla-get-objectname ent) '("AcDbSpline" "AcDbEllipse"))
			(setq lgt (vlax-curve-getdistatparam ent (vlax-curve-getendparam ent)))
		      )
		      ((eq (vla-get-objectname ent) "AcDbMline")
			(setq n 0 pt2 nil lgt 0)
			(while (nth n (setq lst (vlax-get ent 'Coordinates)))
			  (setq pt1 (list (nth n lst)(nth (1+ n) lst)(nth (+ n 2) lst)))
			  (and pt2
			    (setq lgt (+ lgt (distance pt1 pt2)))
			  )
			  (setq pt2 pt1
				n (+ n 3)
			  )
			)
		      )
		      ((member (vla-get-objectname ent) '("AcDbMPolygon" "AcDbRegion"))
			(setq lgt (vla-get-perimeter ent))
		      )
		    )
		    (and (zerop lgt)
			 (setq tot (1+ tot))
		
		      (vla-delete ent)
		    )
		
		  )
		
		)
 	
	      )
		
	      (msg (strcat "   " "Passage " (itoa nbBoucle) " : "(itoa tot) " ligne(s)/polyligne(s)/spline(s)/arc(s)/etc... de longueur 0 effacé(s).\n"))
	      
	      )
	  	)
	  )
;-------------------------------------------------------------------------
; Effacer les textes vide
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 3)))
	    (progn
	      (msg "Recherche des textes vides.")
	      (vlax-for bl (vla-get-blocks doc)
		(or (wcmatch (nombl bl) "*|*")
		  (vlax-for ent bl
		    (and (member (vla-get-objectname ent) '("AcDbText" "AcDbMText"))
			 (member (vla-get-textstring ent) '("" " " "  "))
			 (setq tot (1+ tot))
		      (vla-delete ent)
		    )
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " texte(s) vide effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les caractères nom imprimable
; Merci à BIGC-ROMU pour le lisp et à celui qui l'a écrit (gile)
; Modifié pour l'adapter au lisp global
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 18)))
	    (progn
	      (msg "Recherche des caractères non imprimable.")
	      (and (ssget "_x" '((0 . "TEXT,MTEXT,INSERT")))
		(progn
		  (vlax-for ent (setq sel (vla-get-activeselectionset doc))
		    (if (= (vla-get-objectname ent) "AcDbBlockReference")
		      (foreach att (vlax-invoke ent 'getattributes)
			(or (eq (setq txt (RightCleanText (vla-get-textstring att))) (vla-get-textstring att))
			  (vla-put-textstring att txt)
			  (setq tot (1+ tot))
			)
		      )
		      (progn
			(setq txt (RightCleanText (vla-get-textstring ent)))
			(or (eq (vla-get-textstring ent) txt)
			  (if (= "" txt)
			    (vla-delete ent)
			    (vla-put-textstring ent txt)
			  )
			  (setq tot (1+ tot))
			)
		      )
		    )
		  )
		  (vla-delete sel)
		)
	      )
	      (msg (strcat "   " (itoa tot) " attribut(s)/texte(s) modifié(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les wipeouts
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 20)))
	    (progn
	      (msg "Recherche des wipeouts.")
	      (vlax-for bl (vla-get-blocks doc)
		(or (wcmatch (nombl bl) "*|*")
		  (vlax-for ent bl
		    (and (eq (vla-get-objectname ent) "AcDbWipeout")
		      (setq tot (1+ tot))
		      (vla-delete ent)
		    )
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " wipeout(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les présentations vides
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 22)))
	    (progn
	      (msg "Recherche des présentations vides.")
	      (vlax-for bl (vla-get-layouts doc)
		(and (not (wcmatch (nombl bl) "*|*"))
		     (< (vla-get-count (vla-get-block bl)) 2)
		  (eff bl)
		)
	      )
	      (msg (strcat "   " (itoa tot) " Présentation(s) vide effacée(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les blocs vides
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 4)))
	    (progn
	      (msg "Recherche des blocs vides.")
	      (vlax-for bl (vla-get-blocks doc)
		(and (not (wcmatch (nombl bl) "*|*"))
		     (zerop (vla-get-count bl))
		     (eq (vla-get-islayout bl) :vlax-false)
		  (progn
		    (and (ssget "_x" (list (cons 0 "insert") (cons 2 (strcat "`**," (nombl bl)))))
		      (progn
			(vlax-map-collection (setq sel (vla-get-activeselectionset doc))
					     '(lambda(ent)
					       (and (eq (nombl bl) (nombl ent))
						 (vla-delete ent)
					       )
					     )
			)
			(vla-delete sel)
		      )
		    )
		    (eff bl)
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " bloc(s) vide effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les groupes vide
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 5)))
	    (progn
	      (msg "Recherche des groupes vides.")
	      (vlax-for ent (vla-get-groups doc)
		(and (zerop (vla-get-count ent))
		     (setq tot (1+ tot))
		  (vla-delete ent)
		)
	      )
	      (msg (strcat "   " (itoa tot) " groupe(s) vide effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les images orphelines
; Merci à (gile) pour la trame du lisp
; Modifié pour l'adapter au lisp global
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 17)))
	    (progn
	      (msg "Recherche des images orphelines.")
	      (or (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-get-dictionaries doc) "ACAD_IMAGE_DICT"))))
		(progn
		  (vlax-for ent dic
		    (setq img (cons ent img))
		  )


		  (and (ssget "_x" (list (cons 0 "IMAGE")))
		    (progn
		      (vlax-for ent (setq sel (vla-get-activeselectionset doc))
				(setq listeEnt '())
				(setq listeEnt (cons ent listeEnt))
				(setq catch (vl-catch-all-apply 'vla-get-name listeEnt))
				(if (vl-catch-all-error-p catch)
					(progn
						;(alert (vl-catch-all-error-message catch))
					)
					(setq img (vl-remove (vla-item dic catch) img))
				)
				(princ "\n")
		      )
		      (vla-delete sel)
		    )
		  )

		 
		  (and img
		    (vlax-for bl (vla-get-blocks doc)
		      (or  (eq (vla-get-islayout bl) :vlax-true)
			   (wcmatch (vla-get-name bl) "*|*")
			   (zerop (vla-get-count bl))
			(vlax-for ent bl
			  (and (eq (vla-get-objectname ent) "AcDbRasterImage")
			    (setq img (vl-remove (vl-catch-all-apply 'vla-item (list dic (vla-get-name ent))) img))
			  )
			)
		      )
		    )
		  )
		  (mapcar '(lambda(x)(or (vl-catch-all-error-p (vl-catch-all-apply 'vla-delete (list x)))
				       (setq tot (1+ tot))
				     )
			  )
			  img
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " image(s) orpheline(s) effacée(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les xrefs orphelins
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 21)))
	    (progn
	      (msg "Recherche des xrefs orphelins.")
	      (vlax-for ent (vla-get-blocks (vla-get-activedocument (vlax-get-acad-object)))
		(or (eq (vla-get-isxref ent) :vlax-false)
		    (ssget "x" (list (cons 0 "insert") (cons 2 (vla-get-name ent))))
		  (progn
		    (or (vl-catch-all-error-p (vl-catch-all-apply 'vla-detach (list ent)))
		      (setq tot (1+ tot))
		    )
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " xref(s) orphelin(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les Xdatas
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 6)))
	    (progn
	    	(setq tmp 1) ; Initialisation (pour rentrer au moins une fois dans la boucle)
	    	(setq nbBoucle 0)
			(while (and (/= tmp 0) (< nbBoucle nbBoucleMax))	    	(setq nbBoucle (1+ nbBoucle))
	      	(msg "Recherche des Xdatas.")
	     	 (and (setq tot 0
			 	js (ssget "_x" '((-3 ("*"))))
		  	 	   )
				(while (setq ent (ssname js tot))
		 			(setq ent (entget ent '("*")))
		  			(foreach ele (cdr (assoc -3 ent))
		    			(setq ent (subst (cons -3 (list (cons (car ele) nil))) (assoc -3 ent) ent)
			 			tot (1+ tot)
			  
		   				)
		    		(entmod ent)

		 			)
				)
	      	 )
	   
	    	(msg (strcat "   " "Passage " (itoa nbBoucle) " : " (itoa tot) " Xdata(s) effacé(s).\n"))
	   	
	   		)
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les proxys
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 7)))
	    (progn
	      (msg "Recherche des proxys.")
	      (and (ssget "_x" (list (cons 0 "ACAD_PROXY_ENTITY")))
		(progn
		  (vlax-for ent (setq sel (vla-get-activeselectionset doc))
		    (or (vl-catch-all-error-p (vl-catch-all-apply 'vla-delete (list ent)))
		      (setq tot (1+ tot))
		    )
		  )
		  (vla-delete sel)
		)
	      )
	      (msg (strcat "   " (itoa tot) " proxy(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les zombies dans les blocs
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 8)))
	    (progn
	      (msg "Recherche d'entités zombie dans les blocs.")
	      (vlax-for bl (vla-get-blocks doc)
		(or (wcmatch (vla-get-name bl) "*|*")
		  (vlax-for ent bl
		    (and (eq (vla-get-ObjectName ent) "AcDbZombieEntity")
		      (eff ent)
		    )
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " zombie(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les zombies dans les dictionnaires
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 9)))
	    (progn
	      (msg "Recherche d'entités zombie dans les dictionnaires.")
	      (vlax-for dic (vla-get-dictionaries doc)
		(if (eq (vla-get-objectname dic) "AcDbZombieObject")
		  (eff dic)
		  (and (vlax-property-available-p dic 'count)
		    (vlax-for ent dic
		      (and (eq (vla-get-objectname ent) "AcDbZombieObject")
			(eff ent)
		      )
		    )
		  )
		)
	      )
	      (msg (strcat "   " (itoa tot) " zombie(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Purger la liste d'échelles
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 10)))
	    (progn
	      (msg "Recherche des échelles.")
	      (setq lst_ech (liste_echelles))
	      (vlax-for ent (setq dic (vla-item (vla-get-dictionaries doc) "ACAD_SCALELIST"))
		(or (member (cdr (assoc 300 (entget (vlax-vla-object->ename ent)))) lst_ech) (eff ent))
	      )
	      (and (zerop (vla-get-count dic))
		(dictadd (vlax-vla-object->ename dic)
			 "A0"
			 (entmakex (list '(0 . "SCALE")
					 '(100 . "AcDbScale")
					 '(70 . 0)
					 '(300 . "1:1")
					 '(140 . 1.0)
					 '(141 . 1.0)
					 '(290 . 0)
				   )
			 )
		)
	      )
	      (msg (strcat "   " (itoa tot) " échelle(s) effacée(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les liens dxe
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 11)))
	    (progn
	      (msg "Recherche des liens dxe.")
	      (msg (strcat "   " (itoa (del_dic "ACAD_DATALINK")) " lien(s) dxe effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les filtres de calques
;-------------------------------------------------------------------------


	  (or (zerop (logand var (expt 2 12)))
	    (progn
	      (msg "Recherche des filtres de calques.")
	      (or (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-getextensiondictionary (vla-get-layers doc)) "ACAD_LAYERFILTERS"))))
		  (zerop (setq tot (vla-get-count dic)))
		  (vl-catch-all-apply 'vla-remove (list (vla-getextensiondictionary (vla-get-layers doc)) "ACAD_LAYERFILTERS"))
	      )
	      (or (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-getextensiondictionary (vla-get-layers doc)) "AcLyDictionary"))))
		  (zerop (vla-get-count dic))
		  (progn
		    (setq tot (+ tot (vla-get-count dic)))
		    (vl-catch-all-apply 'vla-remove (list (vla-getextensiondictionary (vla-get-layers doc)) "AcLyDictionary"))
		  )
	      )
	      (msg (strcat "   " (itoa tot) " filtre(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Remplacer les polices de caratères non trouvés
; Merci à (gile) pour la trame du lisp
; Modifié pour l'adapter au lisp global
;-------------------------------------------------------------------------

	    (or (zerop (logand var (expt 2 19)))
	    (progn
	    	(setq maVar 1)
	    	
	      	(msg "Recherche des polices de caractères inconnues du dessin.")

	      	(vlax-for ts (vla-get-TextStyles doc)
				
				(setq 
					name (vla-get-Name ts)
					font (vla-get-FontFile ts)	
				)
			
				(if 
					(and
						(or
							(not (findfile font))
						)
						(setq ext (vl-filename-extension font))
						
						(= (strcase ext) ".SHX")
						
					)
					(progn
						(setq tot (1+ tot))
					)
				)
			)

	      	(msg (strcat "   " (itoa tot) " police(s) créé(s) à partir de \"ltypeshp.shx\".\n"))
	      	
	    	
	   
	    )
	  )

;-------------------------------------------------------------------------
; Nettoyer les dictionnaires
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 13)))
	    (progn
	   
	      (msg "Nettoyer les dictionnaires.")
	      (vlax-for dic (vla-get-dictionaries doc)
		(or (not (vlax-property-available-p dic 'name))
		    (eq (vla-get-name dic) "ACAD_SCALELIST")
		  (eff dic)
		)
	      )
	      (msg (strcat "   " (itoa tot) " élément(s) de dictionnaire(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les dictionnaires vide
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 14)))
	    (progn
	      (msg "Recherche des dictionnaires vides.")
	      (vlax-for dic (vla-get-dictionaries doc)
		(and (eq (vla-get-objectname dic) "AcDbDictionary")
		     (zerop (vla-get-count dic))
		  (eff dic)
		)
	      )
	      (msg (strcat "   " (itoa tot) " dictionnaire(s) vide effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Effacer les dictionnaires
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 15)))
	    (progn
	      (msg "Recherche des dictionnaires.")
	      (vlax-for dic (vla-get-dictionaries doc)
		(or (not (vlax-property-available-p dic 'name))
		    (eq (vla-get-name dic) "ACAD_SCALELIST")
		  (eff dic)
		)
	      )
	      (msg (strcat "   " (itoa (- tdi (vla-get-count (vla-get-dictionaries doc)))) " dictionnaire(s) effacé(s).\n"))
	    )
	  )

;-------------------------------------------------------------------------
; Reverrouilles les calques
;-------------------------------------------------------------------------

	  (mapcar '(lambda(x) (vl-catch-all-apply 'vla-put-lock (list (car x) (cdr x)))) lst_lay)

;-------------------------------------------------------------------------
; Regelle les calques
;-------------------------------------------------------------------------

	  (mapcar '(lambda(x) (vl-catch-all-apply 'vla-put-freeze (list (car x) (cdr x)))) lst_lay_freeze)


;-------------------------------------------------------------------------
; Purger le dessin
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 16)))
	    (progn

	      (msg "Purger le dessin.")
	      (or (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-get-dictionaries doc) "ACAD_TABLESTYLE"))))
		(vlax-for ent dic
		  (or (eq (vla-get-name ent) "Standard") (eff ent))
		)
	      )
	      (or (vl-catch-all-error-p (setq dic (vl-catch-all-apply 'vla-item (list (vla-get-dictionaries doc) "ACAD_MLEADERSTYLE"))))
		(vlax-for ent dic
		  (eff ent)
		)
	      )
	      (and (vlax-property-available-p doc 'MATERIALS)
		
	    ; (vl-load-com)
	    ; (vlax-dump-object(vla-get-ActiveDocument(vlax-get-acad-object))t)

	    ; Affichage sur AutoCad : 
	    ; Materials (RO) = #<VLA-OBJECT IAcadMaterials 0fa4f884>
		; ActiveMaterial = #<VLA-OBJECT IAcadMaterial 0fa362b4>  	

		; Affichage sur ZWCAD : 
		; Materials (RO) = NIL
		; ActiveMaterial = NIL
		; http://www.theswamp.org/index.php?topic=24322.0

		; vlax-for plante car vla-get-materials doc vaut NIL

		;(vlax-for ent (vla-get-materials doc)
		;  (eff ent)
		;)
	      )
	      (repeat 3 (vla-purgeall doc))
	    )
	  )

;-------------------------------------------------------------------------
; Contrôle des erreurs
;-------------------------------------------------------------------------

	  (or (zerop (logand var (expt 2 0)))
	    (progn
	      (msg "Contrôle des erreurs.\n")
	      (vla-auditinfo doc :vlax-true)
	    )
	  )

;-------------------------------------------------------------------------
; Boite de dialogue
;-------------------------------------------------------------------------
	  (and bda
	    (progn
	      (mode_tile "accept" 0)
	      (action_tile "accept" "(done_dialog)")
	      (start_dialog)
	      (unload_dialog (car dcl))
	      (vl-file-delete (cdr dcl))
	    )
	  )
	  
	  ; Lancement SHX
	  (if (= maVar 1)
		(progn
			(shx)
		)
	  )

	)
      )
    )
  )
  (vla-endundomark doc)
  (setq *error* s)
  (princ)
)

(defun c:jav()
  (if (zerop (getvar "cmdactive"))
    (patrick:jav T)
    (patrick:jav nil)
  )
)

;*************************************************************************
; Copie la police de caractère ltypeshp.shx en la renommant avec les noms
; des polices non trouvées
;
; Créé par ZWFrance - Fonctionnel pour ZWCad
;
; (C) MARTIN Johan (SM)
;
; V1.0
;
;*************************************************************************

(defun shx (/ name fontf ext)
	(setq cmdecho (getvar "cmdecho"))
	(setvar "cmdecho" 0)
	(vl-load-com)
	(or *acdoc*
		(setq *acdoc* (vla-get-ActiveDocument (vlax-get-acad-object)))
	)
	(vlax-for ts (vla-get-TextStyles *acdoc*)
		(setq 
			name (vla-get-Name ts)
			font (vla-get-FontFile ts)
		)

		(if 
			(and
				(or
				
					(not (findfile font))
				)
				(setq ext (vl-filename-extension font))
				
				(= (strcase ext) ".SHX")
				
			)
			(progn
			
				(setq folder (GETENV "FONTMAP"))
				(setq pos (vl-string-position (ascii ".fmp") folder))
				(setq pos (- pos 5))
				
				(setq folder (substr folder 1 pos))
				(setq pathF (strcat "\"" folder  font "\""))
				;(princ (strcat "\nCreating file " pathF))
				
				(setq pathSHX(findfile "ltypeshp.shx"))
	
				(setq pathSHX (strcat "\"" pathSHX "\""))

		
				(setq com (strcat "copy " pathSHX " " pathF))
				(command "_SHELL" com)
			
			)
		)
		(princ)
	)
	(setvar "cmdecho" cmdecho)
)

(defun c:-jav()
  (patrick:jav nil)
)

(setq nom_lisp "JAV")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " chargé."))
    (princ (strcat "\n" nom_lisp ".LSP Charge.........Tapez " nom_lisp " pour l'executer.")))
  (princ (strcat "\n" nom_lisp ".LSP Charge..........Tapez " nom_lisp " pour l'executer.")))
(setq nom_lisp nil)
(princ)

;***********************************************************************************************************************************************************
;
;TOUT GRIS - Change la propriété de couleur des objets en ducalque et permet de griser un fond de plan - TG.LSP
;
;***********************************************************************************************************************************************************
(defun c:tg (/ tmp file fenetre dcl_id couleur traitement xref)
	(setq 
        tmp  (vl-filename-mktemp "Tmp.dcl")
        file (open tmp "w")
        cmdecho (getvar "cmdecho")
        color 8
 	)

 	(setvar "cmdecho" 0)

	; faire un catch
	; (setq liste '("texte" 1))
	; (setq catch (vl-catch-all-apply '= liste))
	; (if (vl-catch-all-error-p catch)
	; 	(progn
	; 		(alert "Erreur : pas de var")
	; 		(setq texte (itoa 0))
	; 		(setq mtexte (itoa 0))
	; 		(setq bXref (itoa 0))
	; 		(setq cote (itoa 0))
	; 		(setq tableau (itoa 0))
	; 	)
		
	; )

	; (if (= texte nil)
	; 	(progn
	; 		(setq texte (itoa 0))
	; 		(setq mtexte (itoa 0))
	; 		(setq bXref (itoa 0))
	; 		(setq cote (itoa 0))
	; 		(setq tableau (itoa 0))

	; 	)
	; )

				(setq couleur (itoa 0))
				(setq traitement (itoa 0))
				(setq xref (itoa 0))
				

 	(write-line

	    (strcat

	    	"toutGris : dialog
	    	{
				label = \"Tout gris v1.0\";

				: boxed_column
				{
					: button {label = \"Couleur\"; key = \"couleur\";}
					: button {label = \"Lancer le traitement\"; key = \"traitement\";}
					: button {label = \"Selectionner une XRef\"; key = \"xref\";}

				}

				spacer;

				: row
				{
					: button {label = \"Cancel\"; key = \"cancel\"; is_default = false; is_cancel = true;}
				}

	    	}"


	    )

	    file

	)

	(close file)


	(setq dcl_id (load_dialog tmp))
	(setq fenetre 1)

	(while (>= fenetre 1)


		(if (not (new_dialog "toutGris" dcl_id))

	      	(exit)

	    )

	    (set_tile "couleur" couleur)
	    (set_tile "traitement" traitement)
	    (set_tile "xref" xref)
	    
	    (action_tile "couleur" "(done_dialog 4)")
	    (action_tile "traitement" "(done_dialog 2)")
	    (action_tile "xref" "(done_dialog 3)")
	    
	    

		(setq fenetre (start_dialog))

	    (cond
	    	((= fenetre 2)

	    		; (alert "Delock")
	    		; (delock)

	    		;(alert "setCouleurCalque")
				(setCouleurCalque color)
				;(traitement)
				;(alert "setBloc")
	    		(setBloc)
	    		;(alert "setByLayerTexte")
	    		(setByLayerTexte)
	    		;(alert "setByLayerMTexte")
	    		(setByLayerMTexte)
	    		; cote
	    		;(alert "tab")
	    		(tab)
	    		; (alert "lock")
	    		; (lock)
	    		(setq fenetre 1)

	    	)

	    	((= fenetre 3)
	    		(selectXref)
	    		(setq fenetre 1)
	    	)

	    	((= fenetre 4)
	    		(choixCouleur)
	    		(setq fenetre 1)
	    	)

	    )

	

	)
	(setvar "cmdecho" cmdecho)
	(princ)
)



; *************************************************************************
; Gère les Xrefs
; *************************************************************************

(defun selectXref (/ tmp file fenetre dcl_id)
	
	(setq pt nil)
	(while (= (setq pt (entsel "\nSelect Block: ")) nil))
			   
	(command "_refedit" (cadr pt))
		
		; (alert "Delock")
		 ; (delock)

		;(alert "setCouleurCalque")
		(setCouleurCalque color)
		;(traitement)
		;(alert "setBloc")
		(setBloc)
		;(alert "setByLayerTexte")
		(setByLayerTexte)
		;(alert "setByLayerMTexte")
		(setByLayerMTexte)
		; cote
		;(alert "tab")
		(tab)
		; (alert "lock")
		; (lock)
	    		
	    
	(command "_refclose" "_s")
	
	(setq fenetre 1)
	    
)

;*************************************************************************
; Met en by layer les textes sur une ligne
;*************************************************************************

(defun setByLayerTexte (/ text-collection index tcollection-no mtext-obj mtext-data text-value pos pos2 finString debutString maString)

   (setq 
      text-collection (ssget "x" (list (cons 0 "TEXT")))
      index 0
    )

    (if text-collection
      (setq tcollection-no (sslength text-collection))
    	(while (< index tcollection-no)
        
        (setq 
          ; get the entity name
          mtext-obj (ssname text-collection index)
          ; get the entity list
          mtext-data (entget mtext-obj)
          ;;the text color is indicated in the text value ex: \\C5;
          text-value (cdr(assoc 1 mtext-data))
        )
        (setq maString text-value)
        (while (vl-string-search "\\C" maString)
          (setq 
          pos (vl-string-search "\\C" maString)
          pos2 (vl-string-search ";" maString)
          finString (substr maString (+ pos2 2))
          debutString (substr maString 1 pos)
          maString (strcat debutString finString)
          )
        )

        (setq maString (vl-string-translate "}" " " maString))
        (setq maString (vl-string-translate "{" " " maString))
      
        (setq ntext-value maString)
        

        (setq mtext-data (subst (cons 1 ntext-value) (assoc 1 mtext-data)  mtext-data))
        ;then update the entity
        (entmod mtext-data)
        (entupd mtext-obj)
        ; roll the counter
     
        (setq index (+ index 1))
   	)
	
  )
	(command "_regen")
	(princ)

)

;*************************************************************************
; Met en by layer les MText (textes sur plusieurs lignes)
;*************************************************************************

(defun setByLayerMTexte (/ mtext-collection index mcollection-no mtext-obj mtext-data text-value pos pos2 finString debutString maString)

   ; first select all mtext
    (setq 
      mtext-collection (ssget "_x" (list (cons 0 "MTEXT")))
      index 0
    )
    
   (if mtext-collection
    (progn
      (setq mcollection-no (sslength mtext-collection))
     ;;;start the loop
     (while (< index mcollection-no)
       ; get the entity name
       (setq 
          ; get the entity name
          mtext-obj (ssname mtext-collection index)
          ; get the entity list
          mtext-data (entget mtext-obj)
          ;;the text color is indicated in the text value ex: \\C5;
          text-value (cdr(assoc 1 mtext-data))
        )
       ; (princ "\n")
       ; (princ text-value)
      (setq maString text-value)
      (while (vl-string-search "\\C" maString)
        (setq 
          pos (vl-string-search "\\C" maString)
          debutString (substr maString 1 pos)
          pourPos2 (substr maString (+ pos 1))
          pos2 (vl-string-search ";" pourPos2)

          finString (substr pourPos2 (+ pos2 2))
          
          maString (strcat debutString finString)

        )
        ; (princ (strcat "\nMa string : " maString))
        ; (princ (strcat "\nPos 1 : " (itoa pos)))
        ; (princ (strcat "\nDebut string : " debutString))
        ; (princ (strcat "\nPour pos2 : " pourPos2))
        ; (princ (strcat "\nPos 2 : " (itoa pos2)))   
        ; (princ (strcat "\nFin string : " finString)) 
      )
      ; (princ (itoa pos1))
      ; (princ (itoa pos2))
      
      ;(princ (strcat "\nFinString : " finString))
      ;(princ (strcat "\ndebutString : " debutString))

      (setq maString (vl-string-translate "}" "" maString))
      (setq maString (vl-string-translate "{" "" maString))
      ;(princ (strcat "\nMa string : " maString))	

      (setq ntext-value maString)
        

        (setq mtext-data (subst (cons 1 ntext-value) (assoc 1 mtext-data)  mtext-data))
        ;then update the entity
        (entmod mtext-data)
        (entupd mtext-obj)
        ; roll the counter
      
         (setq index (+ index 1)) 
      ;   (princ (strcat("\n Index : " itoa(index))))
  	  )
    )
	
  )
	(command "_regen")
	(princ)
)	

	


;*************************************************************************
; Met en by layer les blocs
;*************************************************************************


(defun setBloc (/ doc)
	
	(vl-load-com)
	(setq doc (vla-get-activedocument (vlax-get-acad-object)))
	
	(vlax-map-collection
    	(vla-get-blocks doc)
  		'(lambda (x)
    		(vlax-for item x
      			;(vla-put-color item 256) ; 256 : by layer

      			
      			(setq listeEnt '())
      			(setq listeEnt (cons 256 listeEnt))
				(setq listeEnt (cons item listeEnt))

      			(setq catch (vl-catch-all-apply 'vla-put-color listeEnt))
      			(if (vl-catch-all-error-p catch)
					(progn
						;(alert (vl-catch-all-error-message catch))
					)
					;(princ item)
				)

            	
    		)
  		 )
	)
	;(vla-regen doc acAllViewports)
	(princ)
)

; ;*************************************************************************
; ; Met en by layer le maximum d'objets possible
; ;*************************************************************************

; (defun traitement (/ acdoc)
; 	(vl-load-com)
; 	(setq acdoc (vla-get-ActiveDocument (vlax-get-acad-object)))
; 	(vlax-for l (vla-get-Layers acdoc)
; 		(vla-put-color l color)
; 	)
	
; 	(princ)
; )

;*************************************************************************
; Change la couleur des calques
;*************************************************************************

(defun setCouleurCalque (color)

	(vl-load-com)

  (setq calques (vla-get-layers (vla-get-ActiveDocument (vlax-get-acad-object))))
    (vlax-for calque calques
      
      (vla-put-color calque color) ; set color au calque
    
    )

    (command "_regen")
)

(defun choixCouleur ()

	(setq color (acad_colordlg 256)) ; selection couleur
	
	  
)

;*************************************************************************
; Change la couleur des textes dans un tableau
;*************************************************************************

(defun tab ()

	(vl-load-com)
  
   	(setq adoc (vla-get-activedocument (vlax-get-acad-object)))
    (vla-endundomark adoc)
    (vla-startundomark adoc)

	(setq tblss (ssget  "_x" (list (cons 0 "acad_table"))))
	(if tblss
		(progn
		   	(setq tblent (ssname tblss 0))

			(setq tblobj (vlax-ename->vla-object tblent))

			
				
			(setq 
				l 0 
				lignes (vla-get-rows tblobj)
				colonnes (vla-get-columns tblobj)
			)
						
			(while (< l lignes)
				(setq c 0)
				(while (< c colonnes)
					(setq cell (vla-gettext tblobj l c))


					;; Algo MTexte
					(setq maString cell)
				    (while (vl-string-search "\\C" maString)
					    (setq 
						    pos (vl-string-search "\\C" maString)
						    pos2 (vl-string-search ";" maString)
						    finString (substr maString (+ pos2 2))
						    debutString (substr maString 1 pos)
						    maString (strcat debutString finString)
					    )
					)

				   	(setq maString (vl-string-translate "}" "" maString))
				   	(setq maString (vl-string-translate "{" "" maString))
				   	;; Fin algo MTexte	


				   	;; Maj dans le tableau
					(vla-settext tblobj l c maString)
					(princ "\n")
					(setq c (1+ c))
				)
				
				(setq l (1+ l))
			)
		)
	)
	
	(princ)
	
)

;;;=================================================================
;;;
;;; RB.LSP V1.11
;;;
;;; Refait tous les blocs de la couleur dubloc et sur le calque 0
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================


(defun rb(/ a b s *errrb*)

  (defun *errrb* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (vla-endundomark doc)
    (setq *error* s)
    (princ)
  )

  (vl-load-com)
  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq s *error*
	*error* *errrb*
  )
  (setq a (tblnext "block" t))
  (while a
    (setq b (cdr (assoc -2 a)))
    (while b
      (setq b (entget b))
      (if (cdr (assoc 6 b))
	(setq b (subst (cons 6 "ByBlock") (assoc 6 b) b))
	(setq b (append b (list (cons 6 "ByBlock"))))
      )
      ;(setq b (subst (cons 8 "0") (assoc 8 b) b))
      
      (if (cdr (assoc 62 b))
  (setq b (subst (cons 62 0) (assoc 62 b) b))
	(setq b (append b (list (cons 62 0))))
      )
      (if (cdr (assoc 370 b))
	(setq b (subst (cons 370 -2) (assoc 370 b) b))
	(setq b (append b (list (cons 370 -2))))
      )
      (entmod b)
      (setq b (entnext (cdr (assoc -1 b))))
    )
    (setq a (tblnext "block"))
  )
  (if (setq a (vl-remove-if-not '(lambda (x) (eq (car x) 350)) (dictsearch (namedobjdict) "ACAD_MLINESTYLE")))
    (foreach b a
      (entmod (append (vl-remove-if '(lambda (x) (eq (car x) 62)) (entget (cdr b))) (list (cons 62 0) (cons 62 0) (cons 62 0))))
    )
  )
  (if (setq a (ssget "_X" (list (cons 0 "INSERT"))))
    (foreach b (mapcar 'cadr (ssnamex a))
      (if (cdr (assoc 66 (entget b)))
	(progn
	  (setq a (entget (entnext b)))
	  (while (not (eq (cdr (assoc 0 a)) "SEQEND"))
	    (entmod (subst (cons 62 0) (assoc 62 a) a))
	    (setq a (entget (entnext (cdr (assoc -1 a)))))
	  )
	)
      )
      (entupd b)
    )
  )
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq *error* s)
  (princ)
)

(defun delock()

	(vl-load-com)
	(setq doc (vla-get-activedocument (vlax-get-acad-object)))
	(vlax-for ent (vla-get-layers doc)
		    (setq lst_lay (cons (cons ent (vla-get-lock ent)) lst_lay))
		    ;(princ lst_lay)
		    (vla-put-lock ent :vlax-false)
		  )
)

(defun lock()
	
	(vl-load-com)
	(setq doc (vla-get-activedocument (vlax-get-acad-object)))
	(mapcar '(lambda(x) (vl-catch-all-apply 'vla-put-lock (list (car x) (cdr x)))) lst_lay)
)
(setq nom_lisp "TG")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " chargé."))
    (princ (strcat "\n" nom_lisp ".LSP Charge..........Tapez " nom_lisp " pour l'executer.")))
  (princ (strcat "\n" nom_lisp ".LSP Charge...........Tapez " nom_lisp " pour l'executer.")))
(setq nom_lisp nil)
(princ)
*
;***********************************************************************************************************************************************************
;
;INSERTOPO - Insere les points depuis un fichier *.txt de coordonnees X,Y,Z - INSERTOPO.LSP - Copyright (C) Lisps de Gile
;
;***********************************************************************************************************************************************************
;;; INSTOPO (gile)
;;; Insere le bloc "PointBloc" sur les points decrit dans un fichier ascii (.txt .csv ou autre)
;;;
;;; Modification : possibilite d'inserer un point 02/12/2009

(defun c:instopo (/	   *error*  makeblock	      filename tmp	file	 layers	  clay
		  ptlay	   blklay   data-sep dec-sep  mat-p    mat	alt	 scl	  point
		  bloc	   dcl_id   status   space    line     coords	matric	 insert	  matp
		  altp	   bname    status   cnt
		 )

  (vl-load-com)
  (or *acdoc*
      (setq *acdoc* (vla-get-ActiveDocument (vlax-get-acad-object)))
  )
  (or *blocks* (setq *blocks* (vla-get-Blocks *acdoc*)))
  (or *layers* (setq *layers* (vla-get-Layers *acdoc*)))

  ;;---------------------------------------------------;;

  (defun *error* (msg)
    (or	(= msg "Fonction annulee")
	(princ (strcat "Erreur: " msg))
    )
    (and file (close file))
    (vla-EndUndoMark *acdoc*)
    (princ)
  )

  ;;---------------------------------------------------;;

  ;; MakeBlock
  ;; Cree le bloc TCPOINT
  (defun makeblock (/ block pt att)
    (vl-load-com)
    (vla-Add *layers* "TopoMat")
    (vla-Add *layers* "TopoAlt")
    (setq block	(vla-add *blocks*
			 (vlax-3d-point '(0. 0. 0.))
			 "TCPOINT"
		)
    )
    (setq pt (vla-addPoint block (vlax-3d-point '(0. 0. 0.))))
    (vla-put-Layer pt "0")
    (vla-put-Color pt acByblock)
    (setq att
	   (vla-addAttribute
	     block
	     0.3
	     acAttributeModePreset
	     ""
	     (vlax-3d-point '(0.1 0.1 0.))
	     "MAT"
	     ""
	   )
    )
    (vla-put-Layer att "TopoMat")
    (setq att
	   (vla-addAttribute
	     block
	     0.3
	     acAttributeModePreset
	     ""
	     (vlax-3d-point '(1. -3. 0.))
	     "ALT"
	     ""
	   )
    )
    (vla-put-Alignment att acAlignmentTopLeft)
    (vla-put-TextAlignmentPoint
      att
      (vlax-3d-point '(0.1 -0.1 0.0))
    )
    (vla-put-Layer att "TopoAlt")
  )

  ;;---------------------------------------------------;;

  (if (setq filename (getfiled "Selectionner un fichier point"
			       ""
			       "txt;csv;*"
			       0
		     )
      )
    (progn
      ;; Creation du fichier DCL temporaire
      (setq tmp	 (vl-filename-mktemp "Tmp.dcl")
	    file (open tmp "w")
      )
      (write-line
	"InsTopo
	:dialog{label=\"InsTopo\";
	:boxed_row{label=\"Format du fichier\";
	:column{
	:button{label=\"Ouvrir le ficher\";key=\"open\";fixed_width=true;}
	:boxed_radio_column{label=\"Separateur de donnees\";key=\"data-sep\";
	:radio_button{label=\"Virgule\";key=\"44\";value =\"1\";}
	:radio_button{label=\"Point-virgule\";key =\"59\";}
	:radio_button{label=\"Espace\";key=\"32\";}
	:radio_button{label=\"Tabulation\";key =\"9\";}}
	}
	:column{
	:boxed_radio_column{label=\"Separateur decimal\";key=\"dec-sep\";
	:radio_button{label=\"Virgule\";key =\"com\";}
	:radio_button{label=\"Point\";key=\"dot\";value=\"1\";}}
	:boxed_radio_column{label=\"Matricule\";key=\"mat-p\";
	:radio_button{label=\"Present\";key=\"present\";value=\"1\";}
	:radio_button{label=\"Absent\";key=\"absent\";}}}}
	
	:boxed_column{label=\"Points\";
	:toggle{label=\"Inserer des points\";key=\"point\";value=\"1\";}
	:row{
	:spacer{width=18;}
	spacer;
	:popup_list{label=\"Calque\";key =\"ptlay\";edit_width = 24;alignment=right;}}
	spacer;}
	
	:boxed_column{label=\"Blocs\";
	:row{
	:toggle{label=\"Inserer des blocs :\";key=\"bloc\";value=\"1\";width=16;}
	:text{value=\"TCPOINT\";key=\"bname\";width=36;}
	}
	:row{
	:boxed_column{label=\"Choix du bloc\";key=\"choice\";
	:toggle{label=\"TCPOINT\";key=\"tcpt\";value=\"1\";}
	:button{label=\"Autre...\";key=\"other\";fixed_width=true;width=14;}}
	spacer;
	:boxed_column{label=\"Attributs\";key=\"atts\";
	:toggle{label=\"Matricule\";key=\"mat\";value=\"1\";}
	:toggle{label=\"Altitude\";key=\"alt\";value=\"1\";}}}
	spacer;
	:row{
	:edit_box{label=\"Echelle  \";key=\"scl\";value=\"1.0\";fixed_width=true;}
	:spacer{width=4;}
	:popup_list{label=\"Calque\";key =\"blklay\";edit_width = 24;}}
	spacer;}
	spacer;ok_cancel_help;}"
	file
      )
      (close file)

      (vlax-for	l (vla-get-Layers *acdoc*)
	(setq layers (cons (vla-get-Name l) layers))
      )
      (setq layers   (vl-sort layers '<)
	    clay     (getvar "CLAYER")
	    ptlay    clay
	    blklay   clay
	    data-sep "44"
	    dec-sep  "dot"
	    mat-p    "present"
	    mat	     "0"
	    alt	     "0"
	    scl	     1.0
	    point    T
	    bloc     nil
	    bname    ""
	    altp     nil
	    matp     nil
	    dcl_id   (load_dialog tmp)
	    status   2
      )
      (while (< 1 status)
	(if (not (new_dialog "InsTopo" dcl_id))
	  (exit)
	)
	(start_list "ptlay")
	(mapcar 'add_list layers)
	(end_list)
	(start_list "blklay")
	(mapcar 'add_list layers)
	(end_list)
	(set_tile "ptlay" (itoa (vl-position ptlay layers)))
	(set_tile "blklay" (itoa (vl-position blklay layers)))
	(foreach k (list "data-sep" "dec-sep" "mat-p" "mat" "alt")
	  (set_tile k (eval (read k)))
	)
	(set_tile "point"
		  (if point
		    "1"
		    "0"
		  )
	)
	(set_tile "bloc"
		  (if bloc
		    "1"
		    "0"
		  )
	)
	(set_tile "bname" bname)
	(set_tile "scl" (rtos scl))
	(if point
	  (mode_tile "ptlay" 0)
	  (mode_tile "ptlay" 1)
	)
	(if bloc
	  (progn
	    (mode_tile "blklay" 0)
	    (mode_tile "scl" 0)
	    (mode_tile "choice" 0)
	    (mode_tile "atts" 0)
	  )
	  (progn
	    (mode_tile "blklay" 1)
	    (mode_tile "scl" 1)
	    (mode_tile "choice" 1)
	    (mode_tile "atts" 1)
	  )
	)
	(if (= bname "TCPOINT")
	  (progn
	    (set_tile "tcpt" "1")
	  )
	  (progn
	    (set_tile "tcpt" "0")
	  )
	)
	(if altp
	  (mode_tile "alt" 0)
	  (mode_tile "alt" 1)
	)
	(if matp
	  (mode_tile "mat" 0)
	  (mode_tile "mat" 1)
	)
	(action_tile "open" "(startapp \"notepad\" filename)")
	(foreach k (list "data-sep" "dec-sep" "mat-p")
	  (action_tile k "(set (read $key) $value)")
	)
	(action_tile
	  "mat-p"
	  "(if (= \"absent\" $value)
	    (progn
	      (mode_tile \"mat\" 1)
	      (set_tile \"mat\" \"0\")
	    )
	    (mode_tile \"mat\" 0)
	  )"
	)
	(action_tile
	  "point"
	  "(if (= \"1\" $value)
            (progn
              (setq point T)
              (mode_tile \"ptlay\" 0)
            )
            (progn
              (setq point nil)
              (mode_tile \"ptlay\" 1)
            )
          )"
	)
	(action_tile
	  "bloc"
	  "(if (= \"1\" $value)
          (progn
            (setq bloc T)
            (mode_tile \"blklay\" 0)
            (mode_tile \"scl\" 0)
            (mode_tile \"choice\" 0)
            (mode_tile \"atts\" 0)
          )
          (progn
            (setq bloc nil)
            (mode_tile \"blklay\" 1)
            (mode_tile \"scl\" 1)
            (mode_tile \"choice\" 1)
            (mode_tile \"atts\" 1)
          )
        )"
	)
	(action_tile
	  "tcpt"
	  "(if (= \"1\" $value)
	    (progn (setq bname \"TCPOINT\") (mode_tile \"atts\" 0))
	    (setq bname \"\")
          )
          (set_tile \"bname\" bname)"
	)
	(action_tile "alt" "(setq alt $value altp (= \"1\" $value))")
	(action_tile "mat" "(setq mat $value matp (= \"1\" $value))")
	(action_tile "other" "(done_dialog 3)")
	(action_tile
	  "ptlay"
	  "(setq ptlay (nth (atoi $value) layers))"
	)
	(action_tile
	  "blklay"
	  "(setq blklay (nth (atoi $value) layers))"
	)
	(action_tile
	  "scl"
	  "(setq scl (distof $value))
	(while (or (not scl) (<= scl 0))
	(alert \"Necessite un nombre reel strictement positif\")
	(setq scl 1.0)
	(set_tile \"scl\" \"1.0\")
	(mode_tile \"scl\" 2))"
	)
	(action_tile "cancel" "(setq data-sep nil) (done_dialog 0)")
	(action_tile
	  "accept"
	  "(if (and bloc (= bname \"\"))
	    (alert \"Aucun bloc specifie\")
	    (done_dialog 1)
	  )"
	)
	(setq status (start_dialog))
	(cond
	  ((= status 3)
	   (setq altp nil
		 matp nil
		 alt  "0"
		 mat  "0"
	   )
	   (if (setq bname (gc:Getblock nil))
	     (progn
	       (if (vl-filename-extension bname)
		 (progn
		   (vla-Delete
		     (vla-InsertBlock
		       (vla-get-ModelSpace *acdoc*)
		       (vlax-3d-point '(0. 0. 0.))
		       bname
		       1.
		       1.
		       1.
		       0.
		     )
		   )
		   (setq bname (vl-filename-base bname))
		 )
	       )
	       (vlax-for o (vla-Item *Blocks* bname)
		 (if
		   (= (vla-get-ObjectName o) "AcDbAttributeDefinition")
		    (cond
		      ((= (strcase (vla-get-TagString o)) "ALT")
		       (setq altp T)
		      )
		      ((= (strcase (vla-get-TagString o)) "MAT")
		       (setq matp T)
		      )
		    )
		 )
	       )
	     )
	     (setq bname ""
		   bloc	nil
	     )
	   )
	  )
	)
      )
      (unload_dialog dcl_id)
      (vl-file-delete tmp)
      (if (= 1 status)
	(progn
	  (vla-StartUndoMark *acdoc*)
	  (and (= bname "TCPOINT")
	       (vl-catch-all-error-p
		 (vl-catch-all-apply
		   'vla-item
		   (list *blocks* "TCPOINT")
		 )
	       )
	       (makeblock)
	  )
	  (setq	space (vla-get-ModelSpace *acdoc*)
		file  (open filename "r")
		cnt   0
	  )
	  (while (setq line (read-line file))
	    (setq coords (gc:str2lst line (chr (atoi data-sep))))
	    (if	(= mat-p "present")
	      (setq matric (car coords)
		    coords (cdr coords)
	      )
	      (setq matric nil)
	    )
	    (if	(= dec-sep "com")
	      (setq
		coords (mapcar
			 '(lambda (x)
			    (read (vl-string-translate "," "." x))
			  )
			 coords
		       )
	      )
	      (setq coords (mapcar 'read coords))
	    )
	    (setq coords (list (car coords)
			       (cadr coords)
			       (cond ((caddr coords))
				     (T 0.0)
			       )
			 )
	    )
	    (if	(vl-every 'numberp coords)
	      (progn
		(setq cnt (1+ cnt))
		(if point
		  (vla-put-Layer
		    (vla-AddPoint space (vlax-3d-point coords))
		    ptlay
		  )
		)
		(if (and bloc (/= bname ""))
		  (progn
		    (setq
		      insert
		       (vla-InsertBlock
			 space
			 (vlax-3d-point coords)
			 bname
			 scl
			 scl
			 scl
			 0.0
		       )
		    )
		    (vla-put-Layer insert blklay)
		    (if	(or altp matp)
		      (foreach att (vlax-invoke insert 'getAttributes)
			(if
			  (and
			    (= (vla-get-TagString att) "MAT")
			    matp
			    matric
			    (= mat "1")
			  )
			   (vla-put-TextString att matric)
			)
			(if
			  (and
			    (= (vla-get-TagString att) "ALT")
			    altp
			    (= alt "1")
			  )
			   (vla-put-TextString att (rtos (caddr coords)))
			)
		      )
		    )
		  )
		)
	      )
	    )
	  )
	  (close file)
	  (vla-EndUndoMark *acdoc*)
	  (princ (strcat
		   "\n"
		   (itoa cnt)
		   (cond
		     ((and point bloc)
		      (if (< 2 cnt)
			" points et blocs inseres"
			" point et bloc insere"
		      )
		     )
		     (point
		      (if (< 2 cnt)
			" points inseres"
			" point insere"
		      )
		     )
		     (bloc
		      (if (< 2 cnt)
			" blocs inseres"
			" bloc insere"
		      )
		     )
		   )
		 )
	  )
	)
      )
    )
  )
  (princ)
)

;; gc:str2lst
;; Transforme un chaine avec separateur en liste de chaines
;;
;; Arguments
;; str : la chaine à transformer en liste
;; sep : le separateur
;;
;; Exemples
;; (gc:str2lst "a b c" " ") -> ("a" "b" "c")
;; (gc:str2lst "1,2,3" ",") -> ("1" "2" "3")
;; (mapcar 'read (gc:str2lst "1,2,3" ",")) -> (1 2 3)

(defun gc:str2lst (str sep / pos)
  (if (setq pos (vl-string-search sep str))
    (cons (substr str 1 pos)
	  (gc:str2lst (substr str (+ (strlen sep) pos 1)) sep)
    )
    (list str)
  )
)

(princ)

;;; gc:Getblock (gile) 03/11/07
;;; Retourne le nom du bloc entre ou choisi par l'utilisateur 
;;; dans une liste deroulante de la boite de dialogue ou depuis la boite
;;; de dialogue standard d'AutoCAD
;;; Argument : le titre (string) ou nil (defaut : "Choisir un bloc")

(defun gc:Getblock (titre / bloc n lst tmp file what_next dcl_id nom)
  (while (setq bloc (tblnext "BLOCK" (not bloc)))
    (setq lst (cons (cdr (assoc 2 bloc)) lst)
    )
  )
  (setq	lst  (acad_strlsort
	       (vl-remove-if
		 (function (lambda (n) (= (substr n 1 1) "*")))
		 lst
	       )
	     )
	tmp  (vl-filename-mktemp "Tmp.dcl")
	file (open tmp "w")
  )
  (write-line
    (strcat
      "getblock:dialog{label="
      (cond (titre (vl-prin1-to-string titre))
	    ("\"Choisir un bloc\"")
      )
      ";initial_focus=\"bl\";:boxed_column{
      :row{:text{label=\"Selectionner\";alignment=left;}
      :button{label=\">>\";key=\"sel\";alignment=right;fixed_width=true;}}
      spacer;
      :column{:button{label=\"Parcourir...\";key=\"wbl\";alignment=right;fixed_width=true;}}
      :column{:text{label=\"Nom :\";alignment=left;}}
      :edit_box{key=\"tp\";edit_width=25;}
      :popup_list{key=\"bl\";edit_width=25;}spacer;}
      spacer;
      ok_cancel;}"
    )
    file
  )
  (close file)
  (setq dcl_id (load_dialog tmp))
  (setq what_next 2)
  (while (>= what_next 2)
    (if	(not (new_dialog "getblock" dcl_id))
      (exit)
    )
    (start_list "bl")
    (mapcar 'add_list lst)
    (end_list)
    (if	(setq n	(vl-position
		  (strcase (getvar "INSNAME"))
		  (mapcar 'strcase lst)
		)
	)
      (setq nom (nth n lst))
      (setq nom	(car lst)
	    n	0
      )
    )
    (set_tile "bl" (itoa n))
    (action_tile "sel" "(done_dialog 5)")
    (action_tile "bl" "(setq nom (nth (atoi $value) lst))")
    (action_tile "wbl" "(done_dialog 3)")
    (action_tile "tp" "(setq nom $value) (done_dialog 4)")
    (action_tile
      "accept"
      "(setq nom (nth (atoi (get_tile \"bl\")) lst)) (done_dialog 1)"
    )
    (setq what_next (start_dialog))
    (cond
      ((= what_next 3)
       (if (setq nom (getfiled "Selectionner un fichier" "" "dwg" 0))
	 (setq what_next 1)
	 (setq what_next 2)
       )
      )
      ((= what_next 4)
       (cond
	 ((not (read nom))
	  (setq what_next 2)
	 )
	 ((tblsearch "BLOCK" nom)
	  (setq what_next 1)
	 )
	 ((findfile (setq nom (strcat nom ".dwg")))
	  (setq what_next 1)
	 )
	 (T
	  (alert (strcat "Le fichier \"" nom "\" est introuvable."))
	  (setq	nom nil
		what_next 2
	  )
	 )
       )
      )
      ((= what_next 5)
       (if (and	(setq ent (car (entsel)))
		(= "INSERT" (cdr (assoc 0 (entget ent))))
	   )
	 (setq nom	 (cdr (assoc 2 (entget ent)))
	       what_next 1
	 )
	 (setq what_next 2)
       )
      )
      ((= what_next 0)
       (setq nom nil)
      )
    )
  )
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  nom
)
(setq nom_lisp "INSTOPO")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charge."))
    (princ (strcat "\n" nom_lisp ".LSP Charge.....Tapez " nom_lisp " pour l'executer.")))
  (princ (strcat "\n" nom_lisp ".LSP Charge......Tapez " nom_lisp " pour l'executer.")))
(setq nom_lisp nil)
(princ)

;**********************************************************************************************************************************************************
;
;ONG - Organisation et gestion des onglets de Présentations - ONG.LSP V3.10 - Copyright (C) Patrick_35
;
;**********************************************************************************************************************************************************

(defun c:ong(/ cmd position resultat s *errong* affiche_ong)

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Gestion des erreurs
  ;;;
  ;;;---------------------------------------------------------------

  (defun *errong* (msg)
    (if (/= msg "Function cancelled")
      (if (= msg "quit / exit abort")
	(princ)
	(princ (strcat "\nErreur : " msg))
      )
      (princ)
    )
    (setq *error* s)
    (setvar "cmdecho" cmd)
    (princ)
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Routine principale
  ;;;
  ;;;---------------------------------------------------------------

  (defun affiche_ong(/ ch choix fi fichier init_ong inv liste_lay n ptxy r resultat sel initialisation)

    (defun initialisation(pos / lay lst)
      (setq n 0 liste_lay nil)
      (vlax-for lay (vla-get-layouts (vla-get-activedocument (vlax-get-acad-object)))
	(setq lst (append lst (list (cons (vla-get-taborder lay) lay))))
      )
      (while (assoc n lst)
	(setq liste_lay (append liste_lay (list (vla-get-name (cdr (assoc n lst))))))
	(if (eq (vla-get-name (cdr (assoc n lst))) (getvar "ctab"))
	  (setq position (itoa n))
	)
	(setq n (1+ n))
      )
    )

    (setq Cle_Patrick_35 "HKEY_CURRENT_USER\\Software\\Autodesk\\Autocad\\Patrick_35")
    (if (setq ch (findfile "Ong.ini"))
      (progn
	(setq fichier (open ch "r"))
	(setq ptxy (list (atoi (read-line fichier))(atoi (read-line fichier))))
	(close fichier)
      )
      (setq ptxy '(-1 -1))
    )
    (setq init_ong (load_dialog (findfile "Ong.dcl")))
    (initialisation 1)
    (while (/= resultat 1)
      (new_dialog "ong" init_ong "" ptxy)
      (setq n 0)
      (start_list "present")
      (while (nth n liste_lay)
	(add_list (nth n liste_lay))
	(setq n (1+ n))
      )
      (end_list)
      (set_tile "total" "Gestion des Onglets V3.10")
      (set_tile "present" position)
      (if (not c:oog)
	(mode_tile "oog" 1)
      )
      (if (not c:mim)
	(mode_tile "mim" 1)
      )
      (if (not c:mpl)
	(mode_tile "mpl" 1)
      )
      (mode_tile "present" 2)
      (action_tile "present"   "(setq position $value)")
      (action_tile "inv"       "(setq inv $value)")
      (action_tile "choisir"   "(done_dialog 2)")
      (action_tile "renommer"  "(done_dialog 3)")
      (action_tile "effacer"   "(done_dialog 4)")
      (action_tile "nouveau"   "(done_dialog 5)")
      (action_tile "gabarit"   "(done_dialog 6)")
      (action_tile "copier"    "(done_dialog 7)")
      (action_tile "page"      "(done_dialog 8)")
      (action_tile "tracer"    "(done_dialog 9)")
      (action_tile "trier"     "(done_dialog 10)")
      (action_tile "oog"       "(done_dialog 11)")
      (action_tile "mim"       "(done_dialog 12)")
      (action_tile "mpl"       "(done_dialog 13)")
      (action_tile "accept"    "(setq ptxy (done_dialog 1))")
      (action_tile "cancel"    "(setq ptxy (done_dialog 0))")
      (setq resultat (start_dialog))
      (cond
	((= resultat 2)
	  (setq position (itoa (read position)))
	  (command "_.layout" "_set" (nth (atoi position) liste_lay))
	)
	((= resultat 3)
	  (setq sel position)
	  (if (= (read position) 0)
	    (alert "Impossible de renommer l'espace Objet")
	    (progn
	      (while (setq n (read sel))
		(setq choix (nth n liste_lay))
		(new_dialog "edi" init_ong)
		(set_tile "texte" "Renommer")
		(set_tile "select" choix)
		(mode_tile "select" 2)
		(action_tile "select" "(setq choix $value)")
		(action_tile "accept" "(done_dialog 1)")
		(action_tile "cancel" "(done_dialog 0)")
		(setq r (start_dialog))
		(if (= r 1)
		  (progn
		    (if (vl-position choix liste_lay)
		      (alert (strcat "Présentation " choix " existante"))
		      (if (and choix (/= choix "") (/= choix (nth n liste_lay)))
			(progn
			  (command "_.layout" "_ren" (nth n liste_lay) choix)
			  (setq liste_lay (subst choix (nth n liste_lay) liste_lay))
			)
		      )
		    )
		  )
		)
		(setq sel (substr sel (+ 2 (strlen (itoa n)))))
	      )
	    )
	  )
	)
	((= resultat 4)
	  (if (= (read position) 0)
	    (alert "Impossible d'effacer l'espace Objet")
	    (progn
	      (setq sel position)
	      (while (setq n (read sel))
		(command "_.layout" "_del" (nth n liste_lay))
		(setq sel (substr sel (+ 2 (strlen (itoa n)))))
	      )
	      (initialisation 0)
	      (while (not (nth (atoi position) liste_lay))
		(setq position (itoa (1- (atoi position))))
	      )
	    )
	  )
	)
	((= resultat 5)
	  (setq position (itoa (read position)))
	  (command "_.layout" "_new" "")
	  (initialisation 0)
	)
	((= resultat 6)
	  (if (setq fichier (getfiled "Choisissez un fichier Gabarit" "template\\" "dwt" 4))
	    (progn
	      (command "_.layout" "_temp" fichier "*")
	      (initialisation 0)
	    )
	  )
	)
	((= resultat 7)
	  (setq sel position)
	  (while (setq n (read sel))
	    (command "_.layout" "_copy" (nth n liste_lay) "")
	    (setq sel (substr sel (+ 2 (strlen (itoa n)))))
	  )
	  (initialisation 0)
	)
	((= resultat 8)
	  (setq sel position)
	  (while (setq n (read sel))
	    (command "_.layout" "_set" (nth n liste_lay))
	    (command "_.pagesetup")
	    (setq sel (substr sel (+ 2 (strlen (itoa n)))))
	  )
	)
	((= resultat 9)
	  (setq sel position pos "")
	  (if (eq inv "1")
	    (progn
	      (while (not (eq sel ""))
		(setq pos (strcat (itoa (read sel)) " " pos))
		(setq sel (substr sel (+ 2 (strlen (itoa (read sel)))) (strlen sel)))
	      )
	      (setq sel (substr pos 1 (1- (strlen pos))))
	    )
	  )
	  (while (setq n (read sel))
	    (command "_plot" "n" (nth n liste_lay) "" "" "n" "n" "o")
	    (setq sel (substr sel (+ 2 (strlen (itoa n)))))
	  )
	)
	((= resultat 10)
	  (setq liste_lay (append (list "Model") (acad_strlsort (cdr liste_lay))))
	)
	((= resultat 11)
	  (c:oog)
	)
	((= resultat 12)
	  (c:mim)
	)
	((= resultat 13)
	  (c:mpl)
	)
      )
    )
    (unload_dialog init_ong)
    (setq fichier (open (vl-string-subst "Ong.ini" "Ong.lsp" (findfile "Ong.lsp")) "w"))
    (write-line (itoa (car ptxy)) fichier)
    (write-line (itoa (cadr ptxy)) fichier)
    (close fichier)
  )

  ;;;---------------------------------------------------------------
  ;;;
  ;;; Routine de lancement
  ;;;
  ;;;---------------------------------------------------------------

  (setq s *error*)
  (setq *error* *errong*)
  (setq cmd (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_.undo" "_group")
  (affiche_ong)
  (command "_.undo" "_end")
  (setq *error* s)
  (setvar "cmdecho" cmd)
  (princ)
)

(setq nom_lisp "ONG")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " chargé."))
    (princ (strcat "\n" nom_lisp ".LSP Charge..........Tapez " nom_lisp " pour l'executer.")))
  (princ (strcat "\n" nom_lisp ".LSP Charge..........Tapez " nom_lisp " pour l'executer.")))
(setq nom_lisp nil)
(princ)

;****************************************************************************************************************************************************************************
;
;INCREMENT -  Incrémenter une valeur numérique, alphabétique ou alphanumérique dans une chaîne de caractères (texte ou attribut) - Copyright (C) Lisps de Gile - version 2.0 
;
;****************************************************************************************************************************************************************************

;|
Ces commandes sont toutes basees sur la routine Insuff qui permet d'incrementer les caracteres numeriques et/ou alphabetiques a la fin d'une chaîne.
INCTXT et INCATT inserent respectivement un texte ou un bloc avec attribut dont une partie est incrementee.
INSEL et INCSUF incrementent respectivement une partie ou la fin des textes/attributs successivement selectionnes a fonction du premier selectionne.
INCADD ajoute au debut ou a la fin des textes/attributs selectionnes une chaîne contenant une valeur incrementee.
INCR permet de choisir parmi ces commandes.

Revision : 11/05/2008
|;

;;=================== SOUS-ROUTINES ===================;;

;; INCSUFF (version 1.2) -Gilles Chanteau- 15/01/08
;; Incremente le suffixe d'une chaîne de caracteres de la valeur specifiee.
;; Est pris en compte comme suffixe, l'ensemble des caracteres [0-9] et/ou [A-Z]
;; et/ou [a-z] depuis la fin du texte, en fonction de la valeur de alpha
;;
;; Arguments
;; str : une chaîne avec un suffixe valide
;; inc : un entier positif
;; alpha : un entier, somme des codes binaires suivant
;; 1 pour les caracteres [0-9]
;; 2 pour les caracteres [A-Z]
;; 4 pour les caracteres [a-z]
;;
;; Retour
;; la chaîne avec son suffixe incremente (ou nil si aucun suffixe valide)
;;
;; Exemples :
;; (incsuff "N°002" 12 1) = "N°014"
;; (incsuff "Dessin9" 1 1) = "Dessin10"
;; (incsuff "test_ZZ9" 1 3) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 1) = "test_ZZ10"
;; (incsuff "12-" 1 1) = nil
;;
;; Modification (13/02/08) : codes binaires pour l'argument alpha

(defun incsuff (str inc alpha / lst crt pas ind val quo ret)
  (setq lst (reverse (vl-string->list str)))
  (while
    (and
      (setq crt (car lst))
      (cond
	((and (< 47 crt 58) (= 1 (logand 1 alpha)))
	 (setq pas 10
	       ind 48
	 )
	)
	((and (< 64 crt 91) (= 2 (logand 2 alpha)))
	 (setq pas 26
	       ind 65
	 )
	)
	((and (< 96 crt 123) (= 4 (logand 4 alpha)))
	 (setq pas 26
	       ind 97
	 )
	)
	((< 0 quo)
	 (setq crt (if (= 10 pas)
		     ind
		     (1- ind)
		   )
	       lst (cons (car lst) lst)
	 )
	)
      )
    )
     (setq val (- crt ind)
	   quo (/ (+ val inc) pas)
	   ret (cons (+ ind (rem (+ val inc) pas)) ret)
     )
     (if (zerop quo)
       (setq ret (append (reverse (cdr lst)) ret)
	     lst nil
       )
       (if (cdr lst)
	 (setq lst (cdr lst)
	       inc quo
	 )
	 (setq lst (list ind)
	       inc (if (= 10 pas)
		     quo
		     (1- quo)
		   )
	 )
       )
     )
  )
  (if ret
    (vl-list->string ret)
  )
)

;;==================================================;;

;; IncValue
;; Incremente un valeur dans les textes ou attributs selectionnes
;;
;; Arguments
;; pref : prefixe (string)
;; val : valeur a incrementer (string)
;; suff : suffixe (string)
;; inc : valeur d'increment (entier, positif)
;; bin : type de caracteres a incrementer (entier, code binaire)
;; typ : type d'entite (string, valeur du code de groupe DXF 0)
;; tag : Etiquette d'attribut (string)
;; save : liste de sauvegarde des anciennes valeurs de texte (liste d'association)

(defun incvalue	(pref val suff inc bin typ save prop / ent elst)
  (while (or (initget 1 "annUler")
	     (setq ent (nentsel
			 (strcat "\nSelectionnez le texte suivant"
				 (if save
				   " ou [annUler]: "
				   ":"
				 )
			 )
		       )
	     )
	 )
    (if	(= ent "annUler")
      (if save
	(progn
	  (setq elst (car save))
	  (entmod elst)
	  (and (= typ "ATTRIB") (entupd (cdr (assoc 330 elst))))
	  (setq	val  (incsuff val (- inc) bin)
		save (cdr save)
	  )
	)
	(princ "\nPlus rien a annuler.")
      )
      (and (setq elst (entget (car ent)))
	   (= (cdr (assoc 0 elst)) typ)
	   (setq save (cons elst save))
	   (setq val (incsuff val inc bin))
	   (if prop
	     (entmod (append (vl-remove-if
			       (function
				 (lambda (x)
				   (member (car x) '(1 8 62 40 7))
				 )
			       )
			       elst
			     )
			     (if (null (assoc 62 prop))
			       '((62 . 256))
			     )
			     (cons (cons 1 (strcat pref val suff)) prop)
		     )
	     )
	     (entmod
	       (subst (cons 1 (strcat pref val suff)) (assoc 1 elst) elst)
	     )
	   )
	   (and (= typ "ATTRIB") (entupd (cdr (assoc 330 elst))))
      )
    )
  )
)

;;==================================================;;

;;; Getblock (gile) 03/11/07
;;; Retourne le nom du bloc entre ou choisi par l'utilisateur 
;;; dans une liste deroulante de la boite de dialogue ou depuis la boite
;;; de dialogue standard d'AutoCAD
;;; Argument : le titre (string) ou nil (defaut : "Choisir un bloc")

(defun getblock	(titre / bloc n lst tmp file what_next dcl_id nom ent)
  (while (setq bloc (tblnext "BLOCK" (not bloc)))
    (setq lst (cons (cdr (assoc 2 bloc)) lst)
    )
  )
  (setq	lst  (acad_strlsort
	       (vl-remove-if
		 (function (lambda (n) (= (substr n 1 1) "*")))
		 lst
	       )
	     )
	tmp  (vl-filename-mktemp "Tmp.dcl")
	file (open tmp "w")
  )
  (write-line
    (strcat
      "getblock:dialog{label="
      (cond (titre (vl-prin1-to-string titre))
	    ("\"Choisir un bloc\"")
      )
      ";initial_focus=\"bl\";:boxed_column{
      :row{:text{label=\"Selectionner\";alignment=left;}
      :button{label=\">>\";key=\"sel\";alignment=right;fixed_width=true;}}
      spacer;
      :column{:button{label=\"Parcourir...\";key=\"wbl\";alignment=right;fixed_width=true;}}
      :column{:text{label=\"Nom :\";alignment=left;}}
      :edit_box{key=\"tp\";edit_width=25;}
      :popup_list{key=\"bl\";edit_width=25;}spacer;}
      spacer;
      ok_cancel;}"
    )
    file
  )
  (close file)
  (setq dcl_id (load_dialog tmp))
  (setq what_next 2)
  (while (>= what_next 2)
    (if	(not (new_dialog "getblock" dcl_id))
      (exit)
    )
    (start_list "bl")
    (mapcar 'add_list lst)
    (end_list)
    (if	(setq n	(vl-position
		  (strcase (getvar "INSNAME"))
		  (mapcar 'strcase lst)
		)
	)
      (setq nom (nth n lst))
      (setq nom	(car lst)
	    n	0
      )
    )
    (set_tile "bl" (itoa n))
    (action_tile "sel" "(done_dialog 5)")
    (action_tile "bl" "(setq nom (nth (atoi $value) lst))")
    (action_tile "wbl" "(done_dialog 3)")
    (action_tile "tp" "(setq nom $value) (done_dialog 4)")
    (action_tile
      "accept"
      "(setq nom (nth (atoi (get_tile \"bl\")) lst)) (done_dialog 1)"
    )
    (setq what_next (start_dialog))
    (cond
      ((= what_next 3)
       (if (setq nom (getfiled "Selectionner un fichier" "" "dwg" 0))
	 (setq what_next 1)
	 (setq what_next 2)
       )
      )
      ((= what_next 4)
       (cond
	 ((not (read nom))
	  (setq what_next 2)
	 )
	 ((tblsearch "BLOCK" nom)
	  (setq what_next 1)
	 )
	 ((findfile (setq nom (strcat nom ".dwg")))
	  (setq what_next 1)
	 )
	 (T
	  (alert (strcat "Le fichier \"" nom "\" est introuvable."))
	  (setq	nom nil
		what_next 2
	  )
	 )
       )
      )
      ((= what_next 5)
       (if (and	(setq ent (car (entsel)))
		(= "INSERT" (cdr (assoc 0 (entget ent))))
	   )
	 (setq nom	 (cdr (assoc 2 (entget ent)))
	       what_next 1
	 )
	 (setq what_next 2)
       )
      )
      ((= what_next 0)
       (setq nom nil)
      )
    )
  )
  (unload_dialog dcl_id)
  (vl-file-delete tmp)
  nom
)

;;=================== COMMANDES ===================;;

;; INCSUF (gile) 14/02/08 -version 2.2-
;; Incremente le suffixe des textes, mtextes ou attributs successivement selectionnes.
;; Le suffixe est determine automatiquement en fonction de la nature des caraceres qui
;; le compose et du parametre "Type(s) de caratere du suffixe" courant.
;; L'utilisateur peut modifier les parametres courants dans une boite dialogue.
;;
;; Modif 10/04/08 plus de contrôle sur l'etiquette de l'attribut

(defun c:incsuf	(/	 ValidSel	 temp	 typ	 inc	 cp
		 file	 dcl_id	 what_next	 ent	 elst	 val
		 prop	 save
		)

  (defun ValidSel (elst / val)
    (setq val (cdr (assoc 1 elst))
	  val (ascii (substr val (strlen val)))
    )
    (or
      (and (= 1 (logand 1 *suffixbin*)) (< 47 val 58))
      (and (= 2 (logand 2 *suffixbin*)) (< 64 val 91))
      (and (= 4 (logand 4 *suffixbin*)) (< 96 val 123))
    )
  )

  (or *suffixbin* (setq *suffixbin* 1))
  (or *incrvalue* (setq *incrvalue* 1))
  (setq	typ  *suffixbin*
	inc  *incrvalue*
	cp   0
	temp (vl-filename-mktemp "Tmp.dcl")
	file (open temp "w")
  )
  (write-line
    (strcat
      "IncsuffInputbox:dialog{"
      "label=\"Parametres\";"
      ":boxed_column{"
      "label=\"Type(s) de caractere du suffixe\";"
      ":toggle{"
      "label=\"Nombres [0-9]\";key=\"num\";}"
      ":toggle{"
      "label=\"Majuscules [A-Z]\";key=\"maj\";}"
      ":toggle{"
      "label=\"Minuscules [a-z]\";key=\"min\";}}"
      "spacer;"
      ":edit_box{"
      "label=\"Increment\";key=\"inc\";edit_width=6;allow_accept=true;}"
      ":toggle{"
      "label=\"Copier les proprietes\";key=\"cp\";}"
      "spacer;ok_cancel; }"
     )
    file
  )
  (close file)
  (setq	dcl_id	  (load_dialog temp)
	what_next 2
  )
  (while (>= what_next 2)
    (if	(not (new_dialog "IncsuffInputbox" dcl_id))
      (exit)
    )
    (if	(= 1 (logand 1 typ))
      (set_tile "num" "1")
    )
    (if	(= 2 (logand 2 typ))
      (set_tile "maj" "1")
    )
    (if	(= 4 (logand 4 typ))
      (set_tile "min" "1")
    )
    (set_tile "inc" (itoa inc))
    (action_tile "cp" "(setq cp (atoi $value))")
    (action_tile
      "accept"
      "(setq typ (+
       (if (= (get_tile \"num\") \"1\") 1 0)
       (if (= (get_tile \"maj\") \"1\") 2 0)
       (if (= (get_tile \"min\") \"1\") 4 0))
       inc (read (get_tile \"inc\")))
       (cond
       ((zerop typ)
       (alert \"Au moins un type de caractere doit etre coche.\")
       (setq typ *suffixbin*) (done_dialog 2))
       ((or (/= (type inc) 'INT) (< inc 0))
       (alert \"L'increment doit etre un entier positif.\")
       (setq inc *incrvalue*)  (done_dialog 2))
       (T (done_dialog 1)))"
    )
    (action_tile "cancel" "(setq typ nil) (done_dialog 0)")
    (setq what_next (start_dialog))
  )
  (unload_dialog dcl_id)
  (vl-file-delete temp)
  (if typ
    (progn
      (setq *suffixbin*	typ
	    *incrvalue*	inc
      )
      (while
	(not
	  (and
	    (setq ent (nentsel
			"\nSelectionnez le texte de depart: "
		      )
	    )
	    (setq elst (entget (car ent)))
	    (setq typ (cdr (assoc 0 elst)))
	    (member typ '("ATTRIB" "TEXT" "MTEXT"))
	    (setq val (cdr (assoc 1 elst)))
	    (or	(zerop cp)
		(setq prop (vl-remove nil
				      (mapcar
					(function
					  (lambda (n)
					    (assoc n elst)
					  )
					)
					'(8 62 40 7)
				      )
			   )
		)
	    )
	  )
	)
      )
      (if (ValidSel elst)
	(IncValue "" val "" *incrvalue* *suffixbin* typ save prop)
	(princ "\nParametre de suffixe incorrect.")
      )
    )
  )
  (princ)
)

;;==================================================;;

;; INCTXT (gile) 31/03/08
;; Insertions multiples d'un texte avec une valeur a incrementer.
;; La valeur a incrementer peut etre de type numerique, alphabetique,
;; ou une combinaison alphanumerique.

(defun c:inctxt	(/ temp	file dcl_id slst st jlst ju ht ro val inc pref suff hor
		 vert nor dlst pt)

  (setq	temp (vl-filename-mktemp "Tmp.dcl")
	file (open temp "w")
  )
  (write-line
    (strcat
      "IncTxt:dialog{"
      "label=\"Texte incremente\";"
      ":boxed_column{"
      "label=\"Mise en forme\";"
      ":row{"
      ":column{"
      ":popup_list{"
      "label=\"Style\";key=\"st\";edit_width=16;}"
      ":popup_list{"
      "label=\"Justification\";key=\"ju\";edit_width=16;}}"
      ":column{"
      ":edit_box{"
      "label=\"Hauteur\";key=\"ht\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Rotation\";key=\"ro\";edit_width=5;allow_accept=true;}}}}"
      ":boxed_row{"
      "label=\"Texte\";"
      ":column{"
      ":edit_box{"
      "label=\"Valeur de depart\";key=\"val\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Increment\";key=\"inc\";edit_width=5;allow_accept=true;}}"
      "spacer;"
      ":column{"
      ":edit_box{"
      "label=\"Prefixe\";key=\"pref\";edit_width=16;allow_accept=true;}"
      ":edit_box{"
      "label=\"Suffixe\";key=\"suff\";edit_width=16;allow_accept=true;}}}"
      "ok_cancel;}"
     )
    file
  )
  (close file)
  (setq dcl_id (load_dialog temp))
  (if (not (new_dialog "IncTxt" dcl_id))
    (exit)
  )
  (while (setq st (tblnext "STYLE" (not st)))
    (if	(/= (cdr (assoc 2 st)) "")
      (setq slst (cons (cdr (assoc 2 st)) slst))
    )
  )
  (setq slst (reverse slst))
  (start_list "st")
  (mapcar 'add_list slst)
  (end_list)
  (setq	jlst '("Gauche"		 "Centre"	   "Droite"
	       "Milieu"		 "Haut Gauche"	   "Haut Centre"
	       "Haut Droite"	 "Milieu Gauche"   "Milieu Centre"
	       "Milieu Droite"	 "Bas Gauche"	   "Bas Centre"
	       "Bas Droite"
	      )
  )
  (start_list "ju")
  (mapcar 'add_list jlst)
  (end_list)
  (or st (setq st (getvar "TEXTSTYLE")))
  (or ju (setq ju "Gauche"))
  (or ht (setq ht (getvar "TEXTSIZE")))
  (or ro (setq ro 0.0))
  (or val (setq val "1"))
  (or inc (setq inc 1))
  (or pref (setq pref ""))
  (or suff (setq suff ""))
  (set_tile "st" (itoa (vl-position st slst)))
  (set_tile "ju" (itoa (vl-position ju jlst)))
  (set_tile "ht" (rtos ht))
  (set_tile "ro" (angtos ro))
  (set_tile "val" val)
  (set_tile "inc" (itoa inc))
  (action_tile "st" "(setq st (nth (atoi $value) slst))")
  (action_tile "ju" "(setq ju (nth (atoi $value) jlst))")
  (action_tile
    "ht"
    "(if (and (numberp (distof $value))
     (< 0 (distof $value)))
     (setq ht (distof $value))
     (progn
     (alert \"Necessite un nombre reel strictement positif\")
     (set_tile \"ht\" (rtos ht))
     (mode_tile \"ht\" 2))))"
  )
  (action_tile
    "ro"
    "(if (numberp (angtof $value))
     (setq ro (angtof $value))
     (progn
     (alert \"Necessite une valeur d'angle valide\")
     (set_tile \"ro\" (angtos ro))
     (mode_tile \"ro\" 2))))"
  )
  (action_tile
    "inc"
    "(if (and (numberp (read $value))
     (<= 0 (read $value)))
     (setq inc (atoi $value))
     (progn
     (alert \"Necessite un entier positif\")
     (set_tile \"inc\" (itoa inc))
     (mode_tile \"inc\" 2))))"
  )
  (action_tile
    "val"
    "(if (wcmatch $value \"~*.*\")
     (setq val $value)
     (progn
     (alert \"Necessite uniquement des caracteres alphabetiques et/ou numeriques\")
     (set_tile \"val\" val)
     (mode_tile \"val\" 2))))"
  )
  (action_tile "pref" "(setq pref $value)")
  (action_tile "suff" "(setq suff $value)")
  (action_tile "accept" "(done_dialog)")
  (action_tile "cancel" "(setq ju nil)")
  (start_dialog)
  (unload_dialog dcl_id)
  (vl-file-delete temp)
  (if ju
    (progn
      (setq hor	 (cond
		   ((wcmatch ju "*Gauche") 0)
		   ((wcmatch ju "*Centre") 1)
		   ((wcmatch ju "*Droite") 2)
		   (T 4)
		 )
	    vert (cond
		   ((wcmatch ju "Haut *") 3)
		   ((wcmatch ju "Milieu *") 2)
		   ((wcmatch ju "Bas *") 1)
		   (T 0)
		 )
	    nor	 (trans '(0 0 1) 1 0 T)
	    dlst (reverse (vl-string->list val))
      )
      (while (setq pt (getpoint "\nSpecifiez le point d'insertion: "))
	(setq pt (trans pt 1 nor))
	(entmake
	  (list
	    '(0 . "TEXT")
	    (cons 10 pt)
	    (cons 40 ht)
	    (cons 50
		  (+ ro (angle '(0 0 0) (trans (getvar "UCSXDIR") 0 nor)))
	    )
	    (cons 7 st)
	    (cons 11 pt)
	    (cons 72 hor)
	    (cons 73 vert)
	    (cons 1 (strcat pref val suff))
	    (cons 210 nor)
	  )
	)
	(setq val (incsuff val inc 7))
      )
    )
  )
  (princ)
)

;;==================================================;;

;;; INCATT (gile) 03/04/08
;;; Insertions multiple d'un bloc avec incrementation d'un attribut
;;; La valeur ² incrementer peut etre de type numerique, alphabetique,
;;; ou une combinaison alphanumerique.

(defun c:incatt	(/ space name lst tmp file dcl_id scl rot tag val inc pref suff
		 ins)

  (vl-load-com)
  (or *acdoc*
      (setq *acdoc* (vla-get-ActiveDocument (vlax-get-acad-object)))
  )
  (setq	space (if (= (getvar "CVPORT") 1)
		(vla-get-PaperSpace *acdoc*)
		(vla-get-ModelSpace *acdoc*)
	      )
  )
  (if (setq name (getblock nil))
    (progn
      (or (tblsearch "BLOCK" name)
	  (vla-delete
	    (vla-InsertBlock
	      space
	      (vlax-3d-point '(0 0 0))
	      name
	      1
	      1
	      1
	      0
	    )
	  )
      )
      (setq name (vl-filename-base name))
      (vlax-for	e (vla-item (vla-get-Blocks *acdoc*) name)
	(if (and
	      (= (vla-get-ObjectName e) "AcDbAttributeDefinition")
	      (= (vla-get-Constant e) :vlax-false)
	    )
	  (setq lst (cons (vla-get-TagString e) lst))
	)
      )
      (if (setq lst (reverse lst))
	(progn
	  (setq	tmp  (vl-filename-mktemp "Tmp.dcl")
		file (open tmp "w")
	  )
	  (write-line
	    (strcat
	      "incins:dialog{"
	      "label=\"Attribut incemente\";"
	      ":boxed_column{"
	      "label=\"Bloc\";"
	      ":edit_box{"
	      "label=\"Echelle globale\";key=\"scl\";edit_width=5;}"
	      ":edit_box{"
	      "label=\"Rotation\";key=\"rot\";edit_width=5;}} "
	      ":boxed_column{"
	      "label=\"Attribut\";"
	      ":popup_list{"
	      "label=\"Etiquette\";key=\"tag\";edit_width=16;}"
	      ":edit_box{"
	      "label=\"Valeur de depart\";key=\"val\";edit_width=5;allow_accept=true;}"
	      ":edit_box{"
	      "label=\"Increment\";key=\"inc\";edit_width=5;allow_accept=true;}"
	      ":edit_box{"
	      "label=\"Prefixe\";key=\"pref\";edit_width=16;allow_accept=true;}"
	      ":edit_box{"
	      "label=\"Suffixe\";key=\"suff\";edit_width=16;allow_accept=true;}}"
	      "ok_cancel;}"
	     )
	    file
	  )
	  (close file)
	  (setq	scl    1.0
		rot    0.0
		val    "1"
		inc    1
		pref   ""
		suff   ""
		dcl_id (load_dialog tmp)
	  )
	  (if (not (new_dialog "incins" dcl_id))
	    (exit)
	  )
	  (start_list "tag")
	  (mapcar 'add_list lst)
	  (end_list)
	  (set_tile "scl" (rtos scl))
	  (set_tile "rot" (rtos rot))
	  (set_tile "val" val)
	  (set_tile "inc" (itoa inc))
	  (action_tile
	    "scl"
	    "(if (and (distof $value)
             (< 0 (distof $value)))
             (setq scl (distof $value))
             (progn
	     (alert \"Necessite un nombre reel strictement positif\")
	     (set_tile \"scl\" (rtos scl))
	     (mode_tile \"scl\" 2)))"
	  )
	  (action_tile
	    "rot"
	    "(if (numberp (angtof $value))
             (setq rot (angtof $value))
             (progn
	     (alert \"Necessite une valeur d'angle valide\")
	     (set_tile \"rot\" (angtos rot))
	     (mode_tile \"rot\" 2)))"
	  )
	  (action_tile
	    "inc"
	    "(if (and (numberp (read $value))
             (<= 0 (read $value)))
             (setq inc (atoi $value))
             (progn
	     (alert \"Necessite un entier positif\")
	     (set_tile \"inc\" (itoa inc))
	     (mode_tile \"inc\" 2))))"
	  )
	  (action_tile
	    "val"
	    "(if (wcmatch $value \"~*.*\")
             (setq val $value)
             (progn
	     (alert \"Necessite uniquement des caracteres alphabetiques et/ou numeriques\")
	     (set_tile \"val\" val)
	     (mode_tile \"val\" 2))))"
	  )
	  (action_tile "pref" "(setq pref $value)")
	  (action_tile "suff" "(setq suff $value)")
	  (action_tile
	    "accept"
	    "(setq tag (atoi (get_tile\"tag\"))) (done_dialog)"
	  )
	  (action_tile "cancel" "(setq tag nil)")
	  (start_dialog)
	  (unload_dialog dcl_id)
	  (vl-file-delete tmp)
	  (if tag
	    (while (setq ins (getpoint "\nSpecifiez le point d'insertion: "))
	      (vla-put-Textstring
		(nth tag
		     (vlax-invoke
		       (vla-InsertBlock
			 space
			 (vlax-3d-point (trans ins 1 0))
			 name
			 scl
			 scl
			 scl
			 rot
		       )
		       'getAttributes
		     )
		)
		(strcat pref val suff)
	      )
	      (setq val (incsuff val inc 7))
	    )
	  )
	)
	(princ "\nCe bloc ne contient pas d'attributs.")
      )
    )
  )
  (princ)
)

;;==================================================;;

;; INCSEL (gile) 05/04/08
;; Incremente par selection successive une valeur contenue dans des textes,
;; mtextes ou attributs.
;;
;; Modif 10/04/08 plus de contrôle sur l'etiquette de l'attribut

(defun c:incsel	(/ temp	file val inc pref suff cp dcl_id ent elst typ prop save)
  (setq	temp (vl-filename-mktemp "Tmp.dcl")
	file (open temp "w")
  )
  (write-line
    (strcat
      "IncselInputbox:dialog{label=\"Parametres\";"
      ":edit_box{"
      "label=\"Valeur de depart\";key=\"val\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Increment\";key=\"inc\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Prefixe\";key=\"pref\";edit_width=16;allow_accept=true;}"
      ":edit_box{"
      "label=\"Suffixe\";key=\"suff\";edit_width=16;allow_accept=true;}"
      ":toggle{"
      "label=\"Copier les proprietes\";key=\"cp\";}"
      "spacer;ok_cancel;}"
     )
    file
  )
  (close file)
  (setq	val    "1"
	inc    1
	pref   ""
	suff   ""
	cp     0
	dcl_id (load_dialog temp)
  )
  (if (not (new_dialog "IncselInputbox" dcl_id))
    (exit)
  )
  (set_tile "val" val)
  (set_tile "inc" (itoa inc))
  (set_tile "cp" (itoa cp))
  (action_tile
    "inc"
    "(if (and (numberp (read $value))
     (<= 0 (read $value)))
     (setq inc (atoi $value))
     (progn
     (alert \"Necessite un entier positif\")
     (set_tile \"inc\" (itoa inc))
     (mode_tile \"inc\" 2))))"
  )
  (action_tile
    "val"
    "(if (wcmatch $value \"~*.*\")
     (setq val $value)
     (progn
     (alert \"Necessite uniquement des caracteres alphabetiques et/ou numeriques\")
     (set_tile \"val\" val)
     (mode_tile \"val\" 2))))"
  )
  (action_tile "pref" "(setq pref $value)")
  (action_tile "suff" "(setq suff $value)")
  (action_tile "cp" "(setq cp (atoi $value))")
  (action_tile "accept" "(done_dialog)")
  (action_tile "cancel" "(setq inc nil)")
  (start_dialog)
  (unload_dialog dcl_id)
  (vl-file-delete temp)
  (if inc
    (progn
      (while
	(not
	  (and
	    (setq ent (nentsel
			"\nSelectionnez le texte de depart: "
		      )
	    )
	    (setq elst (entget (car ent)))
	    (setq typ (cdr (assoc 0 elst)))
	    (member typ '("ATTRIB" "TEXT" "MTEXT"))
	    (or	(zerop cp)
		(setq prop (vl-remove nil
				      (mapcar
					(function
					  (lambda (n)
					    (assoc n elst)
					  )
					)
					'(8 62 40 7)
				      )
			   )
		)
	    )
	  )
	)
      )
      (setq save (cons elst save))
      (entmod
	(subst (cons 1 (strcat pref val suff)) (assoc 1 elst) elst)
      )
      (if (= typ "ATTRIB")
	(entupd (cdr (assoc 330 elst)))
      )
      (IncValue pref val suff inc 7 typ save prop)
    )
  )
  (princ)
)

;;==================================================;;

;; INCADD (gile) 10/04/08
;; Ajoute une valeur incrementee au debut ou a la fin des textes,
;; mtextes ou attributs successivement selectionnes.

(defun c:incadd
		(/ bin inc val pref suff temp typ file dcl_id pos ent elst str
		 save)
  (setq	temp (vl-filename-mktemp "Tmp.dcl")
	file (open temp "w")
  )
  (write-line
    (strcat
      "IncselInputbox:dialog{label=\"Parametres\";"
      ":boxed_radio_column{"
      "label=\"Position\";key=\"pos\";"
      ":radio_button{"
      "label=\"Au debut\";key=\"start\";}"
      ":radio_button{"
      "label=\"A la fin\";key=\"end\";value=\"1\";}}"
      ":edit_box{"
      "label=\"Valeur de depart\";key=\"val\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Increment\";key=\"inc\";edit_width=5;allow_accept=true;}"
      ":edit_box{"
      "label=\"Prefixe\";key=\"pref\";edit_width=16;allow_accept=true;}"
      ":edit_box{"
      "label=\"Suffixe\";key=\"suff\";edit_width=16;allow_accept=true;}"
      "spacer;ok_cancel;}"
     )
    file
  )
  (close file)
  (setq	val    "1"
	inc    1
	pref   ""
	suff   ""
	dcl_id (load_dialog temp)
  )
  (if (not (new_dialog "IncselInputbox" dcl_id))
    (exit)
  )
  (set_tile "val" val)
  (set_tile "inc" (itoa inc))
  (action_tile
    "inc"
    "(if (and (numberp (read $value))
     (<= 0 (read $value)))
     (setq inc (atoi $value))
     (progn
     (alert \"Necessite un entier positif\")
     (set_tile \"inc\" (itoa inc))
     (mode_tile \"inc\" 2))))"
  )
  (action_tile
    "val"
    "(if (wcmatch $value \"~*.*\")
     (setq val $value)
     (progn
     (alert \"Necessite uniquement des caracteres alphabetiques et/ou numeriques\")
     (set_tile \"val\" val)
     (mode_tile \"val\" 2))))"
  )
  (action_tile "pref" "(setq pref $value)")
  (action_tile "suff" "(setq suff $value)")
  (action_tile
    "accept"
    "(setq pos (get_tile \"pos\")) (done_dialog)"
  )
  (action_tile "cancel" "(setq inc nil)")
  (start_dialog)
  (unload_dialog dcl_id)
  (vl-file-delete temp)
  (if inc
    (while (or (initget 1 "annUler")
	       (setq ent (nentsel
			   (strcat "\nSelectionnez un texte"
				   (if save
				     " ou [annUler]: "
				     ":"
				   )
			   )
			 )
	       )
	   )
      (if (= ent "annUler")
	(if save
	  (progn
	    (setq elst (car save))
	    (entmod elst)
	    (and (= "ATTRIB" (cdr (assoc 0 elst)))
		 (entupd (cdr (assoc 330 elst)))
	    )
	    (setq val  (incsuff val (- inc) 7)
		  save (cdr save)
	    )
	  )
	  (princ "\nPlus rien a annuler.")
	)
	(and (setq elst (entget (car ent)))
	     (member (cdr (assoc 0 elst)) '("ATTRIB" "MTEXT" "TEXT"))
	     (setq save (cons elst save))
	     (setq str (cdr (assoc 1 elst)))
	     (entmod
	       (subst (cons 1
			    (if	(= "start" pos)
			      (strcat pref val suff str)
			      (strcat str pref val suff)
			    )
		      )
		      (assoc 1 elst)
		      elst
	       )
	     )
	     (setq val (incsuff val inc 7))
	     (and (= "ATTRIB" (cdr (assoc 0 elst)))
		  (entupd (cdr (assoc 330 elst)))
	     )
	)
      )
    )
  )
  (princ)
)

;; INCR
;; Permet de choisir une fonction d'incrementation

(defun c:incr (/ temp file dcl_id fun)
  (setq	temp (vl-filename-mktemp "Tmp.dcl")
	file (open temp "w")
  )
  (write-line
    (strcat
      "IncrInputbox:dialog{label=\"Incrementer\";" ":radio_column{key=\"fun\";"
      ":radio_button{"
      "label=\"INCTXT Inserer un texte contenant une valeur incrementee\";key=\"c:inctxt\";}"
      ":radio_button{"
      "label=\"INCATT Inserer un bloc contenant un attribut incremente\";key=\"c:incatt\";}"
      ":radio_button{"
      "label=\"INCSEL Incrementer une valeur dans les textes selectionnes\";key=\"c:incsel\";}"
      ":radio_button{"
      "label=\"INCSUF Incrementer la partie finale des textes selectionnes\";key=\"c:incsuf\";}"
      ":radio_button{"
      "label=\"INCADD Ajouter une valeur incrementee aux textes selectionnes\";key=\"c:incadd\";}}"
      "ok_cancel;}")
    file
  )
  (close file)
  (setq dcl_id (load_dialog temp))
  (if (not (new_dialog "IncrInputbox" dcl_id))
    (exit)
  )
  (set_tile "c:inctxt" "1")
  (action_tile
    "accept"
    "(setq fun (get_tile \"fun\")) (done_dialog)"
  )
  (start_dialog)
  (unload_dialog dcl_id)
  (and fun (apply (read fun) nil))
  (princ)
)
(setq nom_lisp "INCR")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " chargé."))
    (princ (strcat "\n" nom_lisp ".LSP Charge.........Tapez " nom_lisp " pour l'executer.")))
  (princ (strcat "\n" nom_lisp ".LSP Charge.........Tapez " nom_lisp " pour l'executer.")))
(setq nom_lisp nil)
(princ)